import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import '@mescius/wijmo.touch';
import * as wjcCore from '@mescius/wijmo';
import * as wjcGrid from '@mescius/wijmo.grid';
import * as wjcGridFilter from '@mescius/wijmo.grid.filter';
import * as wjcGridSearch from '@mescius/wijmo.grid.search';
import * as wjcGridGroupPanel from '@mescius/wijmo.grid.grouppanel';
import * as wjcInput from '@mescius/wijmo.input';
import { CellMaker, SparklineMarkers } from '@mescius/wijmo.grid.cellmaker';
import { KeyValue, Country, DataService } from './data';
import { ExportService } from './export';
//
class App {
constructor(dataSvc, exportSvc) {
this._itemsCount = 500;
this._lastId = this._itemsCount;
this._dataSvc = dataSvc;
this._exportSvc = exportSvc;
// initializes data maps
this._productMap = this._buildDataMap(this._dataSvc.getProducts());
this._countryMap = new wjcGrid.DataMap(this._dataSvc.getCountries(), 'id', 'name');
this._colorMap = this._buildDataMap(this._dataSvc.getColors());
// initializes cell templates
this._historyCellTemplate = CellMaker.makeSparkline({
markers: SparklineMarkers.High | SparklineMarkers.Low,
maxPoints: 25,
label: 'price history',
});
this._ratingCellTemplate = CellMaker.makeRating({
range: [1, 5],
label: 'rating'
});
// initializes data size
document.getElementById('itemsCount').addEventListener('change', (e) => {
const value = e.target.value;
this._itemsCount = wjcCore.changeType(value, wjcCore.DataType.Number);
this._handleItemsCountChange();
});
// initializes export
const btnExportToExcel = document.getElementById('btnExportToExcel');
this._excelExportContext = new ExcelExportContext(btnExportToExcel);
btnExportToExcel.addEventListener('click', () => {
this._exportToExcel();
});
document.getElementById('btnExportToPdf').addEventListener('click', () => {
this._exportToPdf();
});
// initializes the grid
this._initializeGrid();
// initializes items source
this._itemsSource = this._createItemsSource();
this._theGrid.itemsSource = this._itemsSource;
}
close() {
const ctx = this._excelExportContext;
this._exportSvc.cancelExcelExport(ctx);
}
_initializeGrid() {
// creates the grid
this._theGrid = new wjcGrid.FlexGrid('#theGrid', {
autoGenerateColumns: false,
allowAddNew: true,
allowDelete: true,
allowPinning: wjcGrid.AllowPinning.SingleColumn,
newRowAtTop: true,
showMarquee: true,
selectionMode: wjcGrid.SelectionMode.MultiRange,
validateEdits: false,
columns: [
{ binding: 'id', header: 'ID', width: 70, isReadOnly: true },
{
binding: 'date', header: 'Date', format: 'MMM d yyyy', isRequired: false, width: 130,
editor: new wjcInput.InputDate(document.createElement('div'), {
format: 'MM/dd/yyyy',
isRequired: false
})
},
{
binding: 'countryId', header: 'Country', dataMap: this._countryMap, width: 145,
cellTemplate: (ctx) => {
const dataItem = ctx.row.dataItem;
if (wjcCore.isUndefined(dataItem) || dataItem === null) {
return '';
}
const country = this._getCountry(ctx.item);
return `<span class="flag-icon flag-icon-${country.flag}"></span> ${country.name}`;
}
},
{ binding: 'price', header: 'Price', format: 'c', isRequired: false, width: 100 },
{
binding: 'history', header: 'History', width: 180, align: 'center', allowSorting: false,
cellTemplate: this._historyCellTemplate
},
{
binding: 'change', header: 'Change', align: 'right', width: 115,
cellTemplate: (ctx) => {
const dataItem = ctx.row.dataItem;
if (wjcCore.isUndefined(dataItem) || dataItem === null) {
return '';
}
const cls = this._getChangeCls(ctx.value);
const value = this._formatChange(ctx.value);
return `<span class="${cls}">${value}</span>`;
}
},
{
binding: 'rating', header: 'Rating', width: 180, align: 'center', cssClass: 'cell-rating',
cellTemplate: this._ratingCellTemplate
},
{
binding: 'time', header: 'Time', format: 'HH:mm', isRequired: false, width: 95,
editor: new wjcInput.InputTime(document.createElement('div'), {
format: 'HH:mm',
isRequired: false
})
},
{
binding: 'colorId', header: 'Color', dataMap: this._colorMap, width: 145,
cellTemplate: (ctx) => {
const dataItem = ctx.row.dataItem;
if (wjcCore.isUndefined(dataItem) || dataItem === null) {
return '';
}
const color = this._getColor(ctx.item);
return `<span class="color-tile" style="background: ${color.value}"></span> ${color.value}`;
}
},
{ binding: 'productId', header: 'Product', dataMap: this._productMap, width: 145 },
{ binding: 'discount', header: 'Discount', format: 'p0', width: 130 },
{ binding: 'active', header: 'Active', width: 100 }
]
});
// create the grid search box
new wjcGridSearch.FlexGridSearch('#theSearch', {
placeholder: 'Search',
grid: this._theGrid,
cssMatch: ''
});
// adds Excel-like filter
new wjcGridFilter.FlexGridFilter(this._theGrid, {
filterColumns: [
'id', 'date', 'time', 'countryId', 'productId',
'colorId', 'price', 'change', 'discount', 'rating', 'active'
]
});
// adds group panel
new wjcGridGroupPanel.GroupPanel('#theGroupPanel', {
placeholder: 'Drag columns here to create groups',
grid: this._theGrid
});
}
_getCountry(item) {
const country = this._countryMap.getDataItem(item.countryId);
return country ? country : Country.NotFound;
}
_getColor(item) {
const color = this._colorMap.getDataItem(item.colorId);
return color ? color : KeyValue.NotFound;
}
_getChangeCls(value) {
if (wjcCore.isNumber(value)) {
if (value > 0) {
return 'change-up';
}
if (value < 0) {
return 'change-down';
}
}
return '';
}
_formatChange(value) {
if (wjcCore.isNumber(value)) {
return wjcCore.Globalize.formatNumber(value, 'c');
}
if (!wjcCore.isUndefined(value) && value !== null) {
return wjcCore.changeType(value, wjcCore.DataType.String);
}
return '';
}
_exportToExcel() {
const ctx = this._excelExportContext;
if (!ctx.exporting) {
this._exportSvc.startExcelExport(this._theGrid, ctx);
}
else {
this._exportSvc.cancelExcelExport(ctx);
}
}
_exportToPdf() {
this._exportSvc.exportToPdf(this._theGrid, {
countryMap: this._countryMap,
colorMap: this._colorMap,
historyCellTemplate: this._historyCellTemplate
});
}
_createItemsSource() {
const data = this._dataSvc.getData(this._itemsCount);
const view = new wjcCore.CollectionView(data, {
getError: (item, prop) => {
const displayName = this._theGrid.columns.getColumn(prop).header;
return this._dataSvc.validate(item, prop, displayName);
}
});
view.collectionChanged.addHandler((s, e) => {
// initializes new added item with a history data
if (e.action === wjcCore.NotifyCollectionChangedAction.Add) {
e.item.history = this._dataSvc.getHistoryData();
e.item.id = this._lastId;
this._lastId++;
}
});
return view;
}
_disposeItemsSource(itemsSource) {
if (itemsSource) {
itemsSource.collectionChanged.removeAllHandlers();
}
}
// build a data map from a string array using the indices as keys
_buildDataMap(items) {
const map = [];
for (let i = 0; i < items.length; i++) {
map.push({ key: i, value: items[i] });
}
return new wjcGrid.DataMap(map, 'key', 'value');
}
_handleItemsCountChange() {
this._disposeItemsSource(this._itemsSource);
this._lastId = this._itemsCount;
this._itemsSource = this._createItemsSource();
this._theGrid.itemsSource = this._itemsSource;
}
}
//
class ExcelExportContext {
constructor(btn) {
this._exporting = false;
this._progress = 0;
this._preparing = false;
this._btn = btn;
}
get exporting() {
return this._exporting;
}
set exporting(value) {
if (value !== this._exporting) {
this._exporting = value;
this._onPropertyChanged();
}
}
get progress() {
return this._progress;
}
set progress(value) {
if (value !== this._progress) {
this._progress = value;
this._onPropertyChanged();
}
}
get preparing() {
return this._preparing;
}
set preparing(value) {
if (value !== this._preparing) {
this._preparing = value;
this._onPropertyChanged();
}
}
_onPropertyChanged() {
wjcCore.enable(this._btn, !this._preparing);
if (this._exporting) {
const percent = wjcCore.Globalize.formatNumber(this._progress, 'p0');
this._btn.textContent = `Cancel (${percent} done)`;
}
else {
this._btn.textContent = 'Export To Excel';
}
}
}
//
document.readyState === 'complete' ? init() : window.onload = init;
//
function init() {
const dataSvc = new DataService();
const exportSvc = new ExportService();
const app = new App(dataSvc, exportSvc);
window.addEventListener('unload', () => {
app.close();
});
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexGrid Overview</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<main class="container-fluid">
<!-- filter/navigation -->
<div class="row">
<!-- search box -->
<div class="toolbar-item col-sm-3 col-md-5">
<div id="theSearch"></div>
</div>
<!-- data size -->
<div class="toolbar-item col-sm-3 col-md-3">
<div class="input-group">
<span class="input-group-addon">Items:</span>
<select id="itemsCount" class="form-control" aria-label="Data Size">
<option value="5">5</option>
<option value="50">50</option>
<option value="500" selected>500</option>
<option value="5000">5,000</option>
<option value="50000">50,000</option>
<option value="100000">100,000</option>
</select>
</div>
</div>
<!-- export to Excel -->
<div class="toolbar-item col-sm-3 col-md-2">
<button id="btnExportToExcel" class="btn btn-default btn-block">Export To Excel</button>
</div>
<!-- export to PDF -->
<div class="toolbar-item col-sm-3 col-md-2">
<button id="btnExportToPdf" class="btn btn-default btn-block">Export To PDF</button>
</div>
</div>
<!-- the grid -->
<div id="theGroupPanel"></div>
<div id="theGrid"></div>
</main>
</body>
</html>
import * as wjcCore from '@mescius/wijmo';
import { RequiredValidator, MinNumberValidator, MinDateValidator, MaxNumberValidator, MaxDateValidator } from './validation';
//
export class KeyValue {
}
KeyValue.NotFound = { key: -1, value: '' };
//
export class Country {
}
Country.NotFound = { id: -1, name: '', flag: '' };
//
export class DataService {
constructor() {
this._products = ['Widget', 'Gadget', 'Doohickey'];
this._colors = ['Black', 'White', 'Red', 'Green', 'Blue'];
this._countries = [
{ id: 0, name: 'US', flag: 'us' },
{ id: 1, name: 'Germany', flag: 'de' },
{ id: 2, name: 'UK', flag: 'gb' },
{ id: 3, name: 'Japan', flag: 'jp' },
{ id: 4, name: 'Italy', flag: 'it' },
{ id: 5, name: 'Greece', flag: 'gr' }
];
this._validationConfig = {
'date': [
new RequiredValidator(),
new MinDateValidator(new Date('2000-01-01T00:00:00')),
new MaxDateValidator(new Date('2100-01-01T00:00:00'))
],
'time': [
new RequiredValidator(),
new MinDateValidator(new Date('2000-01-01T00:00:00')),
new MaxDateValidator(new Date('2100-01-01T00:00:00'))
],
'productId': [
new RequiredValidator(),
new MinNumberValidator(0, `{0} can't be less than {1} (${this._products[0]})`),
new MaxNumberValidator(this._products.length - 1, `{0} can't be greater than {1} (${this._products[this._products.length - 1]})`)
],
'countryId': [
new RequiredValidator(),
new MinNumberValidator(0, `{0} can't be less than {1} (${this._countries[0].name})`),
new MaxNumberValidator(this._countries.length - 1, `{0} can't be greater than {1} (${this._countries[this._countries.length - 1].name})`)
],
'colorId': [
new RequiredValidator(),
new MinNumberValidator(0, `{0} can't be less than {1} (${this._colors[0]})`),
new MaxNumberValidator(this._colors.length - 1, `{0} can't be greater than {1} (${this._colors[this._colors.length - 1]})`)
],
'price': [
new RequiredValidator(),
new MinNumberValidator(0, `Price can't be a negative value`)
]
};
}
getCountries() {
return this._countries;
}
getProducts() {
return this._products;
}
getColors() {
return this._colors;
}
getHistoryData() {
return this._getRandomArray(25, 100);
}
getData(count) {
const data = [];
const dt = new Date();
const year = dt.getFullYear();
const itemsCount = Math.max(count, 5);
// add items
for (let i = 0; i < itemsCount; i++) {
const item = this._getItem(i, year);
data.push(item);
}
// set invalid data to demonstrate errors visualization
data[1].price = -2000;
data[2].date = new Date('1970-01-01T00:00:00');
data[4].time = undefined;
data[4].price = -1000;
return data;
}
validate(item, prop, displayName) {
const validators = this._validationConfig[prop];
if (wjcCore.isUndefined(validators)) {
return '';
}
const value = item[prop];
for (let i = 0; i < validators.length; i++) {
const validationError = validators[i].validate(displayName, value);
if (!wjcCore.isNullOrWhiteSpace(validationError)) {
return validationError;
}
}
}
_getItem(i, year) {
const date = new Date(year, i % 12, 25, i % 24, i % 60, i % 60);
const countryIndex = this._getRandomIndex(this._countries);
const productIndex = this._getRandomIndex(this._products);
const colorIndex = this._getRandomIndex(this._colors);
const item = {
id: i,
date: date,
time: new Date(date.getTime() + Math.random() * 30 * (24 * 60 * 60 * 1000)),
countryId: this._countries[countryIndex].id,
productId: productIndex,
colorId: colorIndex,
price: wjcCore.toFixed(Math.random() * 10000 + 5000, 2, true),
change: wjcCore.toFixed(Math.random() * 1000 - 500, 2, true),
history: this.getHistoryData(),
discount: wjcCore.toFixed(Math.random() / 4, 2, true),
rating: this._getRating(),
active: i % 4 == 0,
size: Math.floor(100 + Math.random() * 900),
weight: Math.floor(100 + Math.random() * 900),
quantity: Math.floor(Math.random() * 10),
description: "Across all our software products and services, our focus is on helping our customers achieve their goals. Our key principles – thoroughly understanding our customers' business objectives, maintaining a strong emphasis on quality, and adhering to the highest ethical standards – serve as the foundation for everything we do."
};
return item;
}
_getRating() {
return Math.ceil(Math.random() * 5);
}
_getRandomIndex(arr) {
return Math.floor(Math.random() * arr.length);
}
_getRandomArray(len, maxValue) {
const arr = [];
for (let i = 0; i < len; i++) {
arr.push(Math.floor(Math.random() * maxValue));
}
return arr;
}
}
export const Images = {
"germany": "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAALCAIAAAD5gJpuAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAadEVYdFNvZnR3YXJlAFBhaW50Lk5FVCB2My41LjExR/NCNwAAAhBJREFUKFNj8PFx9vG08nG38PGycXOzcnA0s7c3tLfXx4UY3N2tdu3aCEQ7dqzftm3t5s0rN2xYvnbt4lWr5i9bNnvRounz5k6aNatv2rTOiRNbQBo8PW2Aqpuam+vq6qqqqkpLS/Pz8zMzMpOSkqKjo0NCQnx9fV1dXe1sbXt760Ea0jxtTu1YP7+ubnZV1fSSksn5+X0ZGZ2Jic3R0XXBwRU+3oWuLjk2Nqlmpks7q0Aa9rmY/t265m9l5Z/i4t95eb8yMn4mJv6IivoWFPzF2/uzi8tHG5sPxqbvdHU/t5StBGrYa6//Z9NKkOrcvF9paT8TEr5HRn4LCvri5fXZ2Rmo+r2x8TsdnTcqqp/qC1YANewBali/9HduLkh1fDxIdWDgF0/PT05OH62t3xsZvdPRfq2i8kpO7mNN9lKghu2V+n+uLvm1Kfvn+pTvq2K/Lg37ssj/01z3jzMd30+xfDfB6HW31qt2lRdNsh+25cwFati2XP/3x0U/n2V8f5L49VHUlwfBn+56f7zt+v6m7dvr5q+v6L+8qPnivNKzs7LvH+TObgFqWKj/6+3cn69n/Xw95cfLid+fd3992v71SdOXR/WfH1R9ulf28W7xhzv5729nv7+VObdSn2Fdn/62bv0trfqbO/TX1Ouvqtdf2au/ulV/ZZP+4lb9BfX682r0F9fpLyzTX1ipP7lYHwAoyRFNzrKSzQAAAABJRU5ErkJggg==",
"greece": "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAALCAIAAAD5gJpuAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAadEVYdFNvZnR3YXJlAFBhaW50Lk5FVCB2My41LjExR/NCNwAAAgJJREFUKFNF0d1LU3EYB/AnuhgG0WXddBFdRYREDQkT/4GkuxKJXojo2oIuoosMwUJhtJBJJmsOM1diJGtNm869tNNx0xWbNXE6z17OOds523n/nXP21nEL+vK9/HzhgQeO9oaNJlvp6Al2dIfAvAadq3DGB6e9cNIDxxfh2AKY5uHQB4DZg8HVh8lms9loNPoeJPsGE5peU7UaMqpWEdIVpMmKKslIkNCvrTQQBNHW7dTr9UCU8a8zK3jpG1ZcjtDeMO0JUe4AuYLTQ8Oxg8E/29JGrLNZy8z+6HTmuX13+E366cTOk/Htx9bU2HQaTjjA1B00Lmnr3vs/e+7FRVkXJU0QVV5EnKBUOJmtSExZKHMShm/BYXPwymDC0LVazdCX725eurPRdTtmvhm7cCN6fmC9sx8/d/3H2WtY162o6dQcUBRj0Gq1qutVTdNVVUNIUxRVlpEkyaIo8YLIcQLH8YIgxuMJsLkym78r4Tgb2mACsZI/WlzFiz6MXo5QS2Hya6jwJVhwr+UX/TkfRg49w6D/Eeb9zs4tke88Bac7//ZzdmqBeD2/b3Ptjb/ftc7sWJzbY47UC/ufyY/pIxcdkNrjy7zKcogtoxKr0KxMMRJVFAu0kKf4HMllCxyRrxA5NpNlXZ8i8P+R0HokOAHsAJMANoBXAC8BLACjrY4AjPwFh3JwhG+uVAQAAAAASUVORK5CYII=",
"italy": "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAALCAIAAAD5gJpuAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAadEVYdFNvZnR3YXJlAFBhaW50Lk5FVCB2My41LjExR/NCNwAAAX5JREFUKFNdzL1LAnEcx/HPLpSgSy225KIgCinUcA06iKDCXXSSIhUUtAhFijk0SEhj/0ZQJGVhz2GkBv4FIiKHRESE9+D5kNLvd07dl8/4en+BE+BYWw7Iot1uC4LQarWazWaj0ajX6wogAR3gB/gGuSNk3jNk6Uo6VU6Nx+PRiGz0q91wOBxEo/3V1R7LqsHgFw2OSXAQf4pHH6KR2wihE03pYNDv93sej+p0du121e//pEEO5DfR/F2Eu+H0utej2mZTrNau1/sxCZKVJH/Pc0UuXAjrtapSPT8vz80pDKMFWey+7bFFNnQdClwG9LrbpdpikWZn5aWlNg0OkXhNhG5C/iu/78Kn14pC9cyMaDbLbrdAgwx2SjtU533LZ4xey/JEi0aj5HI1aZDC1vOWN+9lzpnF00W9liTRZOpMT3UMBtHh0IIE1h83YvcxvshzhZVJ8K9ZWBBdLqJFu71Bg31gG9gE1gAWtVqtWq2Wy+VSqfSiXQsgjwmlA/4AQZc4Q1AkNCsAAAAASUVORK5CYII=",
"japan": "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAALCAIAAAD5gJpuAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAadEVYdFNvZnR3YXJlAFBhaW50Lk5FVCB2My41LjExR/NCNwAAAVFJREFUKFNVkb2KwkAUhfMwVrHQwh/YWOgWKlin8kks3H0IF6xtbXyAPERQCaISgogEFRE1mcxPsrtnZrIuHobLFN+ZufdcI37VQ+l2u12VLpfL+Xw+Ho9hGB4Oh91+Lw0/St9/yjKcLFUSQnDOGWOU0iRJgiDIDTkr6SxznPTjUwwGfDZ7ooQQVN/3pSFnNT2dpr2e6HR46501GvRrpGlgqNvt9t8g6dMptW3RbvNWi1kNWqsl9TrZbMBEUYS6Wq0MjKhp2fJiIelmk1mWpMtlUizGjgMaGBye5xkIRNMCE4Yh73aZ9Uar1aRUIqYZm2bkeaDv9ztsy+VSGnQaeSDjMa1UcrpQiIZDTUO4SAPChgFoHh9mnExIvx/bdjQaPa5XoHgUwsV1XQOreYb9DDFBJmpK3T1eV38ow+sid1gNwkZ86/UamWBKtDGfz4FKue4vduTCcIOSUSoAAAAASUVORK5CYII=",
"uk": "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAALCAIAAAD5gJpuAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAadEVYdFNvZnR3YXJlAFBhaW50Lk5FVCB2My41LjExR/NCNwAAAepJREFUKFNjmDRz346rb6qnH0tpBqLDiY0Hbt59uza5cU1CHZDhmb3NI22HbcyGqMadcwLzq+ceZViy4tT/jav+/ft/++GXRRtuz19/B8j+P6Xnf18rkDFp4eXeuRdOnnj8r6vm39+fEzZdYEhqObjn5Lv/S5f/P7j3////bdOuAsn/qZn/ExKBdEnfpS+L1nzv7gay5626JGkyA6Rh4Ya7dROvPtx3/09TPUg1EMTE/A+PADFyM/+/eHHhzltHz+VFTUcEdScyAB0KcgMaCA397+cHZcMAUNmZay8Z1iTW/p/c8T8l5X98/P/IyP8hISClPj7/XF1/2dv/tLT8bmLyVU/vq7b2z2C3VnkrHDbY2v4xswCzQHJ///798/fP7z9/Tl59wWAft6lnzvmotB1Xrr7///bNz+R4kCojk9/6hmANf586Oe6fuVVCelZIwnoG4WwG87B1i9eDQuZzY92Hrq6YkmNA9h9t3V+a2kBXW9kv+fn//5dZc18kxDRNPccgmM4wefPlf//+fm+vOHrgdmHDwbyGw0AX/g3x+B3k/O/v3/C0baFxq7cfvvX3z4/XCb7ZRUsYquYdmOKS7Jy5SFBnDo/GZA7VCeevvWiVtmgRNzl95SWDeDGDaAGDcK6IYV3vnuuupnkAPExoqtcH3joAAAAASUVORK5CYII=",
"us": "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAALCAIAAAD5gJpuAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAadEVYdFNvZnR3YXJlAFBhaW50Lk5FVCB2My41LjExR/NCNwAAAeBJREFUKFNVkU1IVFEcxS/ozo0rN24EN2JiOYtyBoYGghEvQoItBCGof9FERB8zfSKOuHAZuEoqUltEkBCRplJpRi2MdhXFMIm+4TGfzud7M/e++7+v/q+k6HKW55zfvecyOPf+n86+A1gHWAVYAXiupy7izdMZ4AbwHeDbwBPAvYDr6kdvUf10FtZRKfXgDUopZtfQcSQdIRqNRp1Ur1uLi3NegNyDU0540jk24QRvy8AteeSGPBgVGI3iKcCREzgwgMGgvjv99Tdhg4qp6eiEY9s2uUulErmbY6JarZbL5WKxWCgUtB6zrOrW1iaje1MgNL7ffTjmdTdHK+z8axwexnAYAwHl86meHn1n/INHgFW6N7krlQq58/l80xUzlUqx48t/unO5XDabTafT31y9tPSEAiv3X6H/uvRdE4cui6ZLuyyyxgZfsgMv0O9XfX2qu1t1djrt7Th99RkRDOMHEbwJLKtWqxGH3vC3O5PJULdpmslkUu8mZ2YmGY3tftzU8ThGIjg6ikNDGAphf7/q7VVdXU5Hh2xrk62toqVFxS/MEyGR+EwTFVxXiP2xbbtGgxCMRiLe3l7ONNE0dwxj24qdZOaZ/z6S9B34F+CfgG8AXwb+FPhj4A+B3yMB/wWYlmDDnRPfSAAAAABJRU5ErkJggg=="
};
@import 'https://cdnjs.cloudflare.com/ajax/libs/flag-icon-css/3.1.0/css/flag-icon.css';
body {
font-size: 1.5em;
font-family: -apple-system, BlinkMacSystemFont, "Segoe UI Light", Roboto, Oxygen-Sans, Ubuntu, Cantarell, "Helvetica Neue", sans-serif;
}
.toolbar-item {
margin-bottom: 6px;
}
.wj-flexgridsearch {
width: 100%;
}
.wj-flexgrid {
height: 330px;
}
.wj-flexgrid .wj-cell {
padding: 7px;
border: none;
}
.wj-cell.wj-state-invalid:not(.wj-header)::after {
top: -14px;
border: 14px solid transparent;
border-right-color: red;
}
.flag-icon {
box-shadow: 1px 1px 4px rgba(0, 0, 0, 0.4);
}
.color-tile {
display: inline-block;
position: relative;
width: 1em;
height: 1em;
border-radius: 50%;
box-shadow: 1px 1px 4px rgba(0, 0, 0, 0.4);
vertical-align: middle;
}
.change-up {
color: darkgreen;
}
.change-up:after {
content: '\25b2';
margin-left: 0.5em;
}
.change-down {
color: darkred;
}
.change-down:after {
content: '\25bc';
margin-left: 0.5em;
}
.cell-rating {
font-size: 12px;
}
.wj-flexgrid .wj-detail {
padding: 4px 16px;
}
.wj-detail h3 {
margin: 10px 0;
}
import * as wjcCore from '@mescius/wijmo';
import * as wjcGrid from '@mescius/wijmo.grid';
import * as wjcGridPdf from '@mescius/wijmo.grid.pdf';
import * as wjcGridXlsx from '@mescius/wijmo.grid.xlsx';
import * as wjcPdf from '@mescius/wijmo.pdf';
import * as wjcXlsx from '@mescius/wijmo.xlsx';
import { KeyValue, Country, Images } from './data';
//
const ExcelExportDocName = 'FlexGrid.xlsx';
const PdfExportDocName = 'FlexGrid.pdf';
const FakeColumn = new wjcGrid.Column();
const FakeRow = new wjcGrid.Row();
//
class Fonts {
}
Fonts.ZapfDingbatsSm = new wjcPdf.PdfFont('zapfdingbats', 8, 'normal', 'normal');
Fonts.ZapfDingbatsLg = new wjcPdf.PdfFont('zapfdingbats', 16, 'normal', 'normal');
//
export class IExcelExportContext {
}
//
export class ExportService {
startExcelExport(flex, ctx) {
if (ctx.preparing || ctx.exporting) {
return;
}
ctx.exporting = false;
ctx.progress = 0;
ctx.preparing = true;
wjcGridXlsx.FlexGridXlsxConverter.saveAsync(flex, {
includeColumnHeaders: true,
includeStyles: false,
formatItem: this._formatExcelItem.bind(this)
}, ExcelExportDocName, () => {
console.log('Export to Excel completed');
this._resetExcelContext(ctx);
}, err => {
console.error(`Export to Excel failed: ${err}`);
this._resetExcelContext(ctx);
}, prg => {
if (ctx.preparing) {
ctx.exporting = true;
ctx.preparing = false;
}
ctx.progress = prg / 100.;
}, true);
console.log('Export to Excel started');
}
cancelExcelExport(ctx) {
wjcGridXlsx.FlexGridXlsxConverter.cancelAsync(() => {
console.log('Export to Excel canceled');
this._resetExcelContext(ctx);
});
}
exportToPdf(flex, options) {
wjcGridPdf.FlexGridPdfConverter.export(flex, PdfExportDocName, {
maxPages: 100,
exportMode: wjcGridPdf.ExportMode.All,
scaleMode: wjcGridPdf.ScaleMode.ActualSize,
documentOptions: {
pageSettings: {
layout: wjcPdf.PdfPageOrientation.Landscape
},
header: {
declarative: {
text: '\t&[Page]\\&[Pages]'
}
},
footer: {
declarative: {
text: '\t&[Page]\\&[Pages]'
}
}
},
styles: {
cellStyle: {
backgroundColor: '#ffffff',
borderColor: '#c6c6c6'
},
altCellStyle: {
backgroundColor: '#f9f9f9'
},
groupCellStyle: {
backgroundColor: '#dddddd'
},
headerCellStyle: {
backgroundColor: '#eaeaea'
},
// Highlight Invalid Cells
errorCellStyle: {
backgroundColor: 'rgba(255, 0, 0, 0.3)'
}
},
customCellContent: false,
formatItem: (e) => this._formatPdfItem(e, options)
});
}
_formatExcelItem(e) {
const panel = e.panel;
if (panel.cellType !== wjcGrid.CellType.Cell) {
return;
}
// highlight invalid cells
if (panel.grid._getError(panel, e.row, e.col)) {
const fill = new wjcXlsx.WorkbookFill();
fill.color = '#ff0000';
e.xlsxCell.style.fill = fill;
}
}
_resetExcelContext(ctx) {
ctx.exporting = false;
ctx.progress = 0;
ctx.preparing = false;
}
_formatPdfItem(e, options) {
const panel = e.panel;
if (panel.cellType !== wjcGrid.CellType.Cell) {
return;
}
switch (panel.columns[e.col].binding) {
case 'countryId':
this._formatPdfCountryCell(e, options.countryMap);
break;
case 'colorId':
this._formatPdfColorCell(e, options.colorMap);
break;
case 'change':
this._formatPdfChangeCell(e);
break;
case 'history':
/*** Version #1: get grid cell produced before by a cell template ***/
// const cell = e.getFormattedCell();
// this._formatPdfHistoryCell(e, cell);
/*** Version #2: create fake cell from a cell template ***/
const history = e.panel.getCellData(e.row, e.col, false);
const cell = this._createCellFromCellTemplate(options.historyCellTemplate, history);
this._formatPdfHistoryCell(e, cell);
break;
case 'rating':
this._formatPdfRatingCell(e);
break;
}
}
_formatPdfCountryCell(e, countryMap) {
e.drawBackground(e.style.backgroundColor);
// check whether country exists
const countryName = e.data;
if (this._isCountryExist(countryName, countryMap)) {
// bound rectangle of cell's content area
const contentRect = e.contentRect;
// draw flag image
const image = e.canvas.openImage(Images[countryName.toLowerCase()]);
const imageTop = contentRect.top + (contentRect.height - image.height) / 2;
e.canvas.drawImage(image, contentRect.left, imageTop);
// draw country name
e.canvas.drawText(countryName, contentRect.left + image.width + 3, e.textTop);
}
// cancel standard cell content drawing
e.cancel = true;
}
_formatPdfColorCell(e, colorMap) {
e.drawBackground(e.style.backgroundColor);
// check whether color exists
const colorName = e.data;
if (this._isColorExist(colorName, colorMap)) {
// bound rectangle of cell's content area
const contentRect = e.contentRect;
// draw color indicator
const imageHeight = Math.min(10, contentRect.height);
const imageWidth = 1.33 * imageHeight;
const imageTop = contentRect.top + (contentRect.height - imageHeight) / 2;
e.canvas.paths
.rect(contentRect.left, imageTop, imageWidth, imageHeight)
.fillAndStroke(wjcCore.Color.fromString(colorName), wjcCore.Color.fromString('gray'));
// draw color name
e.canvas.drawText(colorName, contentRect.left + imageWidth + 3, e.textTop);
}
// cancel standard cell content drawing
e.cancel = true;
}
_formatPdfChangeCell(e) {
e.drawBackground(e.style.backgroundColor);
// get change value and text
const cellData = e.panel.getCellData(e.row, e.col, false);
let change = 0;
let changeText = '';
if (wjcCore.isNumber(cellData)) {
change = cellData;
changeText = wjcCore.Globalize.formatNumber(change, 'c');
}
else if (!wjcCore.isUndefined(cellData) && cellData !== null) {
changeText = wjcCore.changeType(cellData, wjcCore.DataType.String);
}
// determine whether change is positive or negative
let changeIndicator = '';
let changeColor = e.style.color;
if (change > 0) {
changeIndicator = '\x73'; // ▲
changeColor = 'darkgreen';
}
else if (change < 0) {
changeIndicator = '\x74'; // ▼
changeColor = 'darkred';
}
// draw change indicator
let indent = 10;
e.canvas.drawText(changeIndicator, e.contentRect.right - indent, e.contentRect.top + indent, {
brush: changeColor,
font: Fonts.ZapfDingbatsSm
});
// draw change text
indent += 3;
e.canvas.drawText(changeText, e.contentRect.left, e.textTop, {
brush: changeColor,
align: wjcPdf.PdfTextHorizontalAlign.Right,
width: e.contentRect.width - indent
});
// cancel standard cell content drawing
e.cancel = true;
}
_formatPdfHistoryCell(e, cell) {
e.drawBackground(e.style.backgroundColor);
// draw history svg
const svgUrl = this._getHistorySvgDataUrlFromCell(cell, e.clientRect.width, e.clientRect.height);
if (svgUrl) {
let cr = e.contentRect;
e.canvas.drawSvg(svgUrl, cr.left + 2, cr.top + 2, { width: cr.width - 4, height: cr.height - 4 });
}
// cancel standard cell content drawing
e.cancel = true;
}
_getHistorySvgDataUrlFromCell(cell, width, height) {
let dataUrl = null;
// extract SVG from provided cell
const svg = cell.getElementsByTagName('svg')[0];
if (svg) {
const clone = svg.cloneNode(true);
clone.setAttribute('version', '1.1');
clone.setAttributeNS('http://www.w3.org/2000/xmlns/', 'xmlns', 'http://www.w3.org/2000/svg');
clone.style.overflow = 'visible';
clone.style.stroke = '#376092';
clone.style.fill = '#376092';
const s = document.createElement('style');
s.setAttribute('type', 'text/css');
s.innerHTML = `<![CDATA[
line {
stroke-width: 2;
}
circle {
stroke-width: 0;
stroke-opacity: 0;
}
.wj-marker {
fill: #d00000;
opacity: 1;
}
]]>`;
const defs = document.createElement('defs');
defs.appendChild(s);
clone.insertBefore(defs, clone.firstChild);
const outer = document.createElement('div');
outer.appendChild(clone);
dataUrl = 'data:image/svg+xml;base64,' + btoa(unescape(encodeURIComponent(outer.innerHTML)));
}
return dataUrl;
}
_formatPdfRatingCell(e) {
e.drawBackground(e.style.backgroundColor);
// check whether rating is defined
let rating = wjcCore.changeType(e.data, wjcCore.DataType.Number);
if (wjcCore.isInt(rating)) {
const ratingIndicator = '\x48'; // ★
const ratingNormalColor = wjcCore.Color.fromRgba(255, 165, 0, 1); // orange
const ratingLightColor = wjcCore.Color.fromRgba(255, 165, 0, 0.2);
// draw rating indicators
const indent = 16;
const count = 5;
const width = count * indent;
const y = e.clientRect.top + indent;
let x = e.contentRect.left + (e.contentRect.width - width) / 2;
rating = wjcCore.clamp(rating, 1, count);
for (let i = 0; i < count; i++) {
e.canvas.drawText(ratingIndicator, x, y, {
brush: (i < rating) ? ratingNormalColor : ratingLightColor,
font: Fonts.ZapfDingbatsLg,
height: e.clientRect.height
});
x += indent;
}
}
// cancel standard cell content drawing
e.cancel = true;
}
_isCountryExist(countryName, countryMap) {
const countryId = countryMap.getKeyValue(countryName);
if (wjcCore.isUndefined(countryId) || countryId === null) {
return false;
}
if (countryId === Country.NotFound.id) {
return false;
}
return true;
}
_isColorExist(colorName, colorMap) {
const colorId = colorMap.getKeyValue(colorName);
if (wjcCore.isUndefined(colorId) || colorId === null) {
return false;
}
if (colorId === KeyValue.NotFound.key) {
return false;
}
return true;
}
_createCellFromCellTemplate(cellTemplate, data) {
const cell = document.createElement('div');
cellTemplate({
col: FakeColumn,
row: FakeRow,
value: data,
item: null,
text: null
}, cell);
return cell;
}
}
import * as wjcCore from '@mescius/wijmo';
export class RequiredValidator {
validate(name, value) {
const message = name + ' is required';
if (wjcCore.isUndefined(value)) {
return message;
}
const str = wjcCore.changeType(value, wjcCore.DataType.String);
if (wjcCore.isNullOrWhiteSpace(str)) {
return message;
}
return '';
}
}
export class MinValueValidator {
constructor(minValue, message = '{0} can\'t be less than {1}', format = null) {
this.minValue = minValue;
this.message = message;
this.format = format;
}
validate(name, value) {
if (value < this.minValue) {
return wjcCore.format(this.message, {
0: name,
1: this._formatValue(this.minValue)
});
}
return '';
}
}
export class MaxValueValidator {
constructor(maxValue, message = '{0} can\'t be greater than {1}', format = null) {
this.maxValue = maxValue;
this.message = message;
this.format = format;
}
validate(name, value) {
if (value > this.maxValue) {
return wjcCore.format(this.message, {
0: name,
1: this._formatValue(this.maxValue)
});
}
return '';
}
}
export class MinNumberValidator extends MinValueValidator {
constructor(minValue, message = '{0} can\'t be less than {1}', format = 'n') {
super(minValue, message, format);
}
_formatValue(value) {
return wjcCore.Globalize.formatNumber(value, this.format);
}
}
export class MaxNumberValidator extends MaxValueValidator {
constructor(maxValue, message = '{0} can\'t be greater than {1}', format = 'n') {
super(maxValue, message, format);
}
_formatValue(value) {
return wjcCore.Globalize.formatNumber(value, this.format);
}
}
export class MinDateValidator extends MinValueValidator {
constructor(minValue, message = '{0} can\'t be less than {1}', format = 'MM/dd/yyyy') {
super(minValue, message, format);
}
_formatValue(value) {
return wjcCore.Globalize.formatDate(value, this.format);
}
}
export class MaxDateValidator extends MaxValueValidator {
constructor(maxValue, message = '{0} can\'t be greater than {1}', format = 'MM/dd/yyyy') {
super(maxValue, message, format);
}
_formatValue(value) {
return wjcCore.Globalize.formatDate(value, this.format);
}
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
},
meta: {
'*.css': { loader: 'css' },
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/latest/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js',
},
node_modules: {
defaultExtension: 'js',
},
},
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import '@angular/compiler';
import { Component, Inject, enableProdMode, ViewChild, OnDestroy, ɵresolveComponentResources } from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';
import '@mescius/wijmo.touch';
import * as wjcCore from '@mescius/wijmo';
import * as wjcGrid from '@mescius/wijmo.grid';
import { CellMaker, SparklineMarkers } from '@mescius/wijmo.grid.cellmaker';
import { WjGridModule } from '@mescius/wijmo.angular2.grid';
import { WjGridGrouppanelModule } from '@mescius/wijmo.angular2.grid.grouppanel';
import { WjGridFilterModule } from '@mescius/wijmo.angular2.grid.filter';
import { WjGridSearchModule } from '@mescius/wijmo.angular2.grid.search';
import { WjInputModule } from '@mescius/wijmo.angular2.input';
import { AppPipesModule } from './app.pipe';
import { KeyValue, Country, DataService } from './app.data';
import { IExcelExportContext, ExportService } from './app.export';
//
@Component({
standalone: true,
providers: [DataService, ExportService],
imports: [
WjInputModule,
WjGridModule,
WjGridGrouppanelModule,
WjGridFilterModule,
WjGridSearchModule,
AppPipesModule,
BrowserModule,
FormsModule,
],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent implements OnDestroy {
private _itemsCount: number = 500;
private _lastId: number = this._itemsCount;
private _dataSvc: DataService;
private _exportSvc: ExportService;
private _itemsSource: wjcCore.CollectionView;
private _productMap: wjcGrid.DataMap<number, KeyValue>;
private _countryMap: wjcGrid.DataMap<number, Country>;
private _colorMap: wjcGrid.DataMap<number, KeyValue>;
private _historyCellTemplate: wjcGrid.ICellTemplateFunction;
private _ratingCellTemplate: wjcGrid.ICellTemplateFunction;
private _excelExportContext: IExcelExportContext;
wjcCore = wjcCore;
// references FlexGrid named 'flex' in the view
@ViewChild('flex', { static: true }) flex: wjcGrid.FlexGrid;
get productMap(): wjcGrid.DataMap<number, KeyValue> {
return this._productMap;
}
get countryMap(): wjcGrid.DataMap<number, Country> {
return this._countryMap;
}
get colorMap(): wjcGrid.DataMap<number, KeyValue> {
return this._colorMap;
}
get itemsSource(): wjcCore.CollectionView {
return this._itemsSource;
}
get itemsCount(): number {
return this._itemsCount;
}
set itemsCount(value: number) {
if (this._itemsCount != value) {
this._itemsCount = value;
this._handleItemsCountChange();
}
}
get historyCellTemplate(): wjcGrid.ICellTemplateFunction {
return this._historyCellTemplate;
}
get ratingCellTemplate(): wjcGrid.ICellTemplateFunction {
return this._ratingCellTemplate;
}
get excelExportContext(): IExcelExportContext {
return this._excelExportContext;
}
constructor(@Inject(DataService) dataSvc: DataService, @Inject(ExportService) exportSvc: ExportService) {
this._dataSvc = dataSvc;
this._exportSvc = exportSvc;
// initializes items source
this._itemsSource = this._createItemsSource();
// initializes data maps
this._productMap = this._buildDataMap(this._dataSvc.getProducts());
this._countryMap = new wjcGrid.DataMap<number, Country>(this._dataSvc.getCountries(), 'id', 'name');
this._colorMap = this._buildDataMap(this._dataSvc.getColors());
// initializes cell templates
this._historyCellTemplate = CellMaker.makeSparkline({
markers: SparklineMarkers.High | SparklineMarkers.Low,
maxPoints: 25,
label: 'price history',
});
this._ratingCellTemplate = CellMaker.makeRating({
range: [1, 5],
label: 'rating',
});
// initializes export
this._excelExportContext = {
exporting: false,
progress: 0,
preparing: false,
};
}
ngOnDestroy() {
const ctx = this._excelExportContext;
this._exportSvc.cancelExcelExport(ctx);
}
getCountry(item: any) {
const country = this._countryMap.getDataItem(item.countryId);
return country ? country : Country.NotFound;
}
getColor(item: any) {
const color = this._colorMap.getDataItem(item.colorId);
return color ? color : KeyValue.NotFound;
}
exportToExcel() {
const ctx = this._excelExportContext;
if (!ctx.exporting) {
this._exportSvc.startExcelExport(this.flex, ctx);
} else {
this._exportSvc.cancelExcelExport(ctx);
}
}
exportToPdf() {
this._exportSvc.exportToPdf(this.flex, {
countryMap: this._countryMap,
colorMap: this._colorMap,
historyCellTemplate: this._historyCellTemplate,
});
}
private _createItemsSource(): wjcCore.CollectionView {
const data = this._dataSvc.getData(this._itemsCount);
const view = new wjcCore.CollectionView(data, {
getError: (item: any, prop: any) => {
const displayName = this.flex.columns.getColumn(prop) ?
this.flex.columns.getColumn(prop).header :
"";
return this._dataSvc.validate(item, prop, displayName);
},
});
view.collectionChanged.addHandler((s: wjcCore.CollectionView, e: wjcCore.NotifyCollectionChangedEventArgs) => {
// initializes new added item with a history data
if (e.action === wjcCore.NotifyCollectionChangedAction.Add) {
e.item.history = this._dataSvc.getHistoryData();
e.item.id = this._lastId;
this._lastId++;
}
});
return view;
}
private _disposeItemsSource(itemsSource: wjcCore.CollectionView): void {
if (itemsSource) {
itemsSource.collectionChanged.removeAllHandlers();
}
}
// build a data map from a string array using the indices as keys
private _buildDataMap(items: string[]): wjcGrid.DataMap<number, KeyValue> {
const map: KeyValue[] = [];
for (let i = 0; i < items.length; i++) {
map.push({ key: i, value: items[i] });
}
return new wjcGrid.DataMap<number, KeyValue>(map, 'key', 'value');
}
private _handleItemsCountChange() {
this._disposeItemsSource(this._itemsSource);
this._lastId = this._itemsCount;
this._itemsSource = this._createItemsSource();
}
}
//
//
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexGrid Overview</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="https://cdn.jsdelivr.net/npm/core-js/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<main class="container-fluid">
<div class="row">
<!-- search box -->
<div class="toolbar-item col-sm-3 col-md-5">
<wj-flex-grid-search [placeholder]="'Search'" [grid]="flex" cssMatch="">
</wj-flex-grid-search>
</div>
<!-- data size -->
<div class="toolbar-item col-sm-3 col-md-3">
<div class="input-group">
<span class="input-group-addon">Items:</span>
<select class="form-control" [(ngModel)]="itemsCount" aria-label="Data Size">
<option value="5">5</option>
<option value="50">50</option>
<option value="500">500</option>
<option value="5000">5,000</option>
<option value="50000">50,000</option>
<option value="100000">100,000</option>
</select>
</div>
</div>
<!-- export to Excel -->
<div class="toolbar-item col-sm-3 col-md-2">
<button [disabled]="excelExportContext.preparing" (click)="exportToExcel()"
class="btn btn-default btn-block">
{{excelExportContext.exporting ? ('Cancel (' + (excelExportContext.progress | percent) + ' done)') :
'Export To Excel'}}
</button>
</div>
<!-- export to PDF -->
<div class="toolbar-item col-sm-3 col-md-2">
<button (click)="exportToPdf()" class="btn btn-default btn-block">Export To PDF</button>
</div>
</div>
<!-- group panel -->
<wj-group-panel [grid]="flex" [placeholder]="'Drag columns here to create groups'">
</wj-group-panel>
<!-- the grid -->
<wj-flex-grid #flex [autoGenerateColumns]="false" [allowAddNew]="true" [allowDelete]="true"
[allowPinning]="'SingleColumn'" [itemsSource]="itemsSource" [newRowAtTop]="true" [showMarquee]="true"
[selectionMode]="'MultiRange'" [validateEdits]="false">
<wj-flex-grid-filter
[filterColumns]="['id', 'date', 'time', 'countryId', 'productId', 'colorId', 'price', 'change', 'discount', 'rating', 'active']">
</wj-flex-grid-filter>
<wj-flex-grid-column binding="id" header="ID" [width]="70" [isReadOnly]="true"></wj-flex-grid-column>
<wj-flex-grid-column binding="date" header="Date" format="MMM d yyyy" [isRequired]="false" [width]="130"
[editor]="theInputDate">
</wj-flex-grid-column>
<wj-flex-grid-column binding="countryId" header="Country" [dataMap]="countryMap" [width]="145">
<ng-template wjFlexGridCellTemplate cellType="Cell" let-cell="cell">
<span class="flag-icon flag-icon-{{getCountry(cell.item).flag}}"></span>
{{getCountry(cell.item).name}}
</ng-template>
</wj-flex-grid-column>
<wj-flex-grid-column binding="price" header="Price" format="c" [isRequired]="false" [width]="100">
</wj-flex-grid-column>
<wj-flex-grid-column binding="history" header="History" [width]="180" [align]="'center'" [allowSorting]="false"
[cellTemplate]="historyCellTemplate">
</wj-flex-grid-column>
<wj-flex-grid-column binding="change" header="Change" [align]="'right'" [width]="115">
<ng-template wjFlexGridCellTemplate [cellType]="'Cell'" let-cell="cell">
<span [class.change-up]="wjcCore.isNumber(cell?.item?.change) && cell.item.change > 0"
[class.change-down]="wjcCore.isNumber(cell?.item?.change) && cell.item.change < 0">
{{cell.item.change | safeCurrency}}
</span>
</ng-template>
</wj-flex-grid-column>
<wj-flex-grid-column binding="rating" header="Rating" [width]="180" [align]="'center'" cssClass="cell-rating"
[cellTemplate]="ratingCellTemplate">
</wj-flex-grid-column>
<wj-flex-grid-column binding="time" header="Time" format="HH:mm" [isRequired]="false" [width]="95"
[editor]="theInputTime">
</wj-flex-grid-column>
<wj-flex-grid-column binding="colorId" header="Color" [dataMap]="colorMap" [width]="145">
<ng-template wjFlexGridCellTemplate [cellType]="'Cell'" let-cell="cell">
<span class="color-tile" [style.background]="getColor(cell?.item)?.value"></span>
{{getColor(cell.item).value}}
</ng-template>
</wj-flex-grid-column>
<wj-flex-grid-column binding="productId" header="Product" [dataMap]="productMap" [width]="145">
</wj-flex-grid-column>
<wj-flex-grid-column binding="discount" header="Discount" format="p0" [width]="130"></wj-flex-grid-column>
<wj-flex-grid-column binding="active" header="Active" [width]="100"></wj-flex-grid-column>
</wj-flex-grid>
<!-- custom editors -->
<wj-input-date #theInputDate format="MM/dd/yyyy" [isRequired]="false">
</wj-input-date>
<wj-input-time #theInputTime format="HH:mm" [isRequired]="false">
</wj-input-time>
</main>
import { Injectable } from '@angular/core';
import * as wjcCore from '@mescius/wijmo';
import {
IValidator, RequiredValidator, MinNumberValidator, MinDateValidator,
MaxNumberValidator, MaxDateValidator
} from './app.validation';
//
export class KeyValue {
key: number;
value: string;
static NotFound: KeyValue = { key: -1, value: '' };
}
//
export class Country {
name: string;
id: number;
flag: string;
static NotFound: Country = { id: -1, name: '', flag: '' };
}
//
@Injectable()
export class DataService {
private _products: string[] = ['Widget', 'Gadget', 'Doohickey'];
private _colors: string[] = ['Black', 'White', 'Red', 'Green', 'Blue'];
private _countries: Country[] = [
{ id: 0, name: 'US', flag: 'us' },
{ id: 1, name: 'Germany', flag: 'de' },
{ id: 2, name: 'UK', flag: 'gb' },
{ id: 3, name: 'Japan', flag: 'jp' },
{ id: 4, name: 'Italy', flag: 'it' },
{ id: 5, name: 'Greece', flag: 'gr' }
];
private _validationConfig: { [prop: string]: IValidator[] } = {
'date': [
new RequiredValidator(),
new MinDateValidator(new Date('2000-01-01T00:00:00')),
new MaxDateValidator(new Date('2100-01-01T00:00:00'))
],
'time': [
new RequiredValidator(),
new MinDateValidator(new Date('2000-01-01T00:00:00')),
new MaxDateValidator(new Date('2100-01-01T00:00:00'))
],
'productId': [
new RequiredValidator(),
new MinNumberValidator(0, `{0} can't be less than {1} (${this._products[0]})`),
new MaxNumberValidator(
this._products.length - 1,
`{0} can't be greater than {1} (${this._products[this._products.length - 1]})`
)
],
'countryId': [
new RequiredValidator(),
new MinNumberValidator(0, `{0} can't be less than {1} (${this._countries[0].name})`),
new MaxNumberValidator(
this._countries.length - 1,
`{0} can't be greater than {1} (${this._countries[this._countries.length - 1].name})`
)
],
'colorId': [
new RequiredValidator(),
new MinNumberValidator(0, `{0} can't be less than {1} (${this._colors[0]})`),
new MaxNumberValidator(
this._colors.length - 1,
`{0} can't be greater than {1} (${this._colors[this._colors.length - 1]})`
)
],
'price': [
new RequiredValidator(),
new MinNumberValidator(0, `Price can't be a negative value`)
]
};
getCountries(): Country[] {
return this._countries;
}
getProducts(): string[] {
return this._products;
}
getColors(): string[] {
return this._colors;
}
getHistoryData(): number[] {
return this._getRandomArray(25, 100);
}
getData(count: number): any[] {
const data = [];
const dt = new Date();
const year = dt.getFullYear();
const itemsCount = Math.max(count, 5);
// add items
for (let i = 0; i < itemsCount; i++) {
const item = this._getItem(i, year);
data.push(item);
}
// set invalid data to demonstrate errors visualization
data[1].price = -2000;
data[2].date = new Date('1970-01-01T00:00:00');
data[4].time = undefined;
data[4].price = -1000;
return data;
}
validate(item: any, prop: string, displayName: string): string {
const validators: IValidator[] = this._validationConfig[prop];
if (wjcCore.isUndefined(validators)) {
return '';
}
const value = item[prop];
for (let i = 0; i < validators.length; i++) {
const validationError = validators[i].validate(displayName, value);
if (!wjcCore.isNullOrWhiteSpace(validationError)) {
return validationError;
}
}
}
private _getItem(i: number, year: number): any {
const date = new Date(year, i % 12, 25, i % 24, i % 60, i % 60);
const countryIndex = this._getRandomIndex(this._countries)
const productIndex = this._getRandomIndex(this._products);
const colorIndex = this._getRandomIndex(this._colors);
const item = {
id: i,
date: date,
time: new Date(date.getTime() + Math.random() * 30 * (24 * 60 * 60 * 1000)),
countryId: this._countries[countryIndex].id,
productId: productIndex,
colorId: colorIndex,
price: wjcCore.toFixed(Math.random() * 10000 + 5000, 2, true),
change: wjcCore.toFixed(Math.random() * 1000 - 500, 2, true),
history: this.getHistoryData(),
discount: wjcCore.toFixed(Math.random() / 4, 2, true),
rating: this._getRating(),
active: i % 4 == 0,
size: Math.floor(100 + Math.random() * 900),
weight: Math.floor(100 + Math.random() * 900),
quantity: Math.floor(Math.random() * 10),
description: "Across all our software products and services, our focus is on helping our customers achieve their goals. Our key principles – thoroughly understanding our customers' business objectives, maintaining a strong emphasis on quality, and adhering to the highest ethical standards – serve as the foundation for everything we do."
};
return item;
}
private _getRating(): number {
return Math.ceil(Math.random() * 5);
}
private _getRandomIndex(arr: any[]): number {
return Math.floor(Math.random() * arr.length);
}
private _getRandomArray(len: number, maxValue: number): number[] {
const arr: number[] = [];
for (let i = 0; i < len; i++) {
arr.push(Math.floor(Math.random() * maxValue));
}
return arr;
}
}
export const Images = {
"germany": "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAALCAIAAAD5gJpuAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAadEVYdFNvZnR3YXJlAFBhaW50Lk5FVCB2My41LjExR/NCNwAAAhBJREFUKFNj8PFx9vG08nG38PGycXOzcnA0s7c3tLfXx4UY3N2tdu3aCEQ7dqzftm3t5s0rN2xYvnbt4lWr5i9bNnvRounz5k6aNatv2rTOiRNbQBo8PW2Aqpuam+vq6qqqqkpLS/Pz8zMzMpOSkqKjo0NCQnx9fV1dXe1sbXt760Ea0jxtTu1YP7+ubnZV1fSSksn5+X0ZGZ2Jic3R0XXBwRU+3oWuLjk2Nqlmpks7q0Aa9rmY/t265m9l5Z/i4t95eb8yMn4mJv6IivoWFPzF2/uzi8tHG5sPxqbvdHU/t5StBGrYa6//Z9NKkOrcvF9paT8TEr5HRn4LCvri5fXZ2Rmo+r2x8TsdnTcqqp/qC1YANewBali/9HduLkh1fDxIdWDgF0/PT05OH62t3xsZvdPRfq2i8kpO7mNN9lKghu2V+n+uLvm1Kfvn+pTvq2K/Lg37ssj/01z3jzMd30+xfDfB6HW31qt2lRdNsh+25cwFati2XP/3x0U/n2V8f5L49VHUlwfBn+56f7zt+v6m7dvr5q+v6L+8qPnivNKzs7LvH+TObgFqWKj/6+3cn69n/Xw95cfLid+fd3992v71SdOXR/WfH1R9ulf28W7xhzv5729nv7+VObdSn2Fdn/62bv0trfqbO/TX1Ouvqtdf2au/ulV/ZZP+4lb9BfX682r0F9fpLyzTX1ipP7lYHwAoyRFNzrKSzQAAAABJRU5ErkJggg==",
"greece": "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAALCAIAAAD5gJpuAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAadEVYdFNvZnR3YXJlAFBhaW50Lk5FVCB2My41LjExR/NCNwAAAgJJREFUKFNF0d1LU3EYB/AnuhgG0WXddBFdRYREDQkT/4GkuxKJXojo2oIuoosMwUJhtJBJJmsOM1diJGtNm869tNNx0xWbNXE6z17OOds523n/nXP21nEL+vK9/HzhgQeO9oaNJlvp6Al2dIfAvAadq3DGB6e9cNIDxxfh2AKY5uHQB4DZg8HVh8lms9loNPoeJPsGE5peU7UaMqpWEdIVpMmKKslIkNCvrTQQBNHW7dTr9UCU8a8zK3jpG1ZcjtDeMO0JUe4AuYLTQ8Oxg8E/29JGrLNZy8z+6HTmuX13+E366cTOk/Htx9bU2HQaTjjA1B00Lmnr3vs/e+7FRVkXJU0QVV5EnKBUOJmtSExZKHMShm/BYXPwymDC0LVazdCX725eurPRdTtmvhm7cCN6fmC9sx8/d/3H2WtY162o6dQcUBRj0Gq1qutVTdNVVUNIUxRVlpEkyaIo8YLIcQLH8YIgxuMJsLkym78r4Tgb2mACsZI/WlzFiz6MXo5QS2Hya6jwJVhwr+UX/TkfRg49w6D/Eeb9zs4tke88Bac7//ZzdmqBeD2/b3Ptjb/ftc7sWJzbY47UC/ufyY/pIxcdkNrjy7zKcogtoxKr0KxMMRJVFAu0kKf4HMllCxyRrxA5NpNlXZ8i8P+R0HokOAHsAJMANoBXAC8BLACjrY4AjPwFh3JwhG+uVAQAAAAASUVORK5CYII=",
"italy": "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAALCAIAAAD5gJpuAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAadEVYdFNvZnR3YXJlAFBhaW50Lk5FVCB2My41LjExR/NCNwAAAX5JREFUKFNdzL1LAnEcx/HPLpSgSy225KIgCinUcA06iKDCXXSSIhUUtAhFijk0SEhj/0ZQJGVhz2GkBv4FIiKHRESE9+D5kNLvd07dl8/4en+BE+BYWw7Iot1uC4LQarWazWaj0ajX6wogAR3gB/gGuSNk3jNk6Uo6VU6Nx+PRiGz0q91wOBxEo/3V1R7LqsHgFw2OSXAQf4pHH6KR2wihE03pYNDv93sej+p0du121e//pEEO5DfR/F2Eu+H0utej2mZTrNau1/sxCZKVJH/Pc0UuXAjrtapSPT8vz80pDKMFWey+7bFFNnQdClwG9LrbpdpikWZn5aWlNg0OkXhNhG5C/iu/78Kn14pC9cyMaDbLbrdAgwx2SjtU533LZ4xey/JEi0aj5HI1aZDC1vOWN+9lzpnF00W9liTRZOpMT3UMBtHh0IIE1h83YvcxvshzhZVJ8K9ZWBBdLqJFu71Bg31gG9gE1gAWtVqtWq2Wy+VSqfSiXQsgjwmlA/4AQZc4Q1AkNCsAAAAASUVORK5CYII=",
"japan": "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAALCAIAAAD5gJpuAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAadEVYdFNvZnR3YXJlAFBhaW50Lk5FVCB2My41LjExR/NCNwAAAVFJREFUKFNVkb2KwkAUhfMwVrHQwh/YWOgWKlin8kks3H0IF6xtbXyAPERQCaISgogEFRE1mcxPsrtnZrIuHobLFN+ZufdcI37VQ+l2u12VLpfL+Xw+Ho9hGB4Oh91+Lw0/St9/yjKcLFUSQnDOGWOU0iRJgiDIDTkr6SxznPTjUwwGfDZ7ooQQVN/3pSFnNT2dpr2e6HR46501GvRrpGlgqNvt9t8g6dMptW3RbvNWi1kNWqsl9TrZbMBEUYS6Wq0MjKhp2fJiIelmk1mWpMtlUizGjgMaGBye5xkIRNMCE4Yh73aZ9Uar1aRUIqYZm2bkeaDv9ztsy+VSGnQaeSDjMa1UcrpQiIZDTUO4SAPChgFoHh9mnExIvx/bdjQaPa5XoHgUwsV1XQOreYb9DDFBJmpK3T1eV38ow+sid1gNwkZ86/UamWBKtDGfz4FKue4vduTCcIOSUSoAAAAASUVORK5CYII=",
"uk": "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAALCAIAAAD5gJpuAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAadEVYdFNvZnR3YXJlAFBhaW50Lk5FVCB2My41LjExR/NCNwAAAepJREFUKFNjmDRz346rb6qnH0tpBqLDiY0Hbt59uza5cU1CHZDhmb3NI22HbcyGqMadcwLzq+ceZViy4tT/jav+/ft/++GXRRtuz19/B8j+P6Xnf18rkDFp4eXeuRdOnnj8r6vm39+fEzZdYEhqObjn5Lv/S5f/P7j3////bdOuAsn/qZn/ExKBdEnfpS+L1nzv7gay5626JGkyA6Rh4Ya7dROvPtx3/09TPUg1EMTE/A+PADFyM/+/eHHhzltHz+VFTUcEdScyAB0KcgMaCA397+cHZcMAUNmZay8Z1iTW/p/c8T8l5X98/P/IyP8hISClPj7/XF1/2dv/tLT8bmLyVU/vq7b2z2C3VnkrHDbY2v4xswCzQHJ///798/fP7z9/Tl59wWAft6lnzvmotB1Xrr7///bNz+R4kCojk9/6hmANf586Oe6fuVVCelZIwnoG4WwG87B1i9eDQuZzY92Hrq6YkmNA9h9t3V+a2kBXW9kv+fn//5dZc18kxDRNPccgmM4wefPlf//+fm+vOHrgdmHDwbyGw0AX/g3x+B3k/O/v3/C0baFxq7cfvvX3z4/XCb7ZRUsYquYdmOKS7Jy5SFBnDo/GZA7VCeevvWiVtmgRNzl95SWDeDGDaAGDcK6IYV3vnuuupnkAPExoqtcH3joAAAAASUVORK5CYII=",
"us": "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAALCAIAAAD5gJpuAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAadEVYdFNvZnR3YXJlAFBhaW50Lk5FVCB2My41LjExR/NCNwAAAeBJREFUKFNVkU1IVFEcxS/ozo0rN24EN2JiOYtyBoYGghEvQoItBCGof9FERB8zfSKOuHAZuEoqUltEkBCRplJpRi2MdhXFMIm+4TGfzud7M/e++7+v/q+k6HKW55zfvecyOPf+n86+A1gHWAVYAXiupy7izdMZ4AbwHeDbwBPAvYDr6kdvUf10FtZRKfXgDUopZtfQcSQdIRqNRp1Ur1uLi3NegNyDU0540jk24QRvy8AteeSGPBgVGI3iKcCREzgwgMGgvjv99Tdhg4qp6eiEY9s2uUulErmbY6JarZbL5WKxWCgUtB6zrOrW1iaje1MgNL7ffTjmdTdHK+z8axwexnAYAwHl86meHn1n/INHgFW6N7krlQq58/l80xUzlUqx48t/unO5XDabTafT31y9tPSEAiv3X6H/uvRdE4cui6ZLuyyyxgZfsgMv0O9XfX2qu1t1djrt7Th99RkRDOMHEbwJLKtWqxGH3vC3O5PJULdpmslkUu8mZ2YmGY3tftzU8ThGIjg6ikNDGAphf7/q7VVdXU5Hh2xrk62toqVFxS/MEyGR+EwTFVxXiP2xbbtGgxCMRiLe3l7ONNE0dwxj24qdZOaZ/z6S9B34F+CfgG8AXwb+FPhj4A+B3yMB/wWYlmDDnRPfSAAAAABJRU5ErkJggg=="
};
@import 'https://cdnjs.cloudflare.com/ajax/libs/flag-icon-css/3.1.0/css/flag-icon.css';
body {
font-size: 1.5em;
font-family: -apple-system, BlinkMacSystemFont, "Segoe UI Light", Roboto, Oxygen-Sans, Ubuntu, Cantarell, "Helvetica Neue", sans-serif;
}
.toolbar-item {
margin-bottom: 6px;
}
.wj-flexgridsearch {
width: 100%;
}
.wj-flexgrid {
height: 330px;
}
.wj-flexgrid .wj-cell {
padding: 7px;
border: none;
}
.wj-cell.wj-state-invalid:not(.wj-header)::after {
top: -14px;
border: 14px solid transparent;
border-right-color: red;
}
.flag-icon {
box-shadow: 1px 1px 4px rgba(0, 0, 0, 0.4);
}
.color-tile {
display: inline-block;
position: relative;
width: 1em;
height: 1em;
border-radius: 50%;
box-shadow: 1px 1px 4px rgba(0, 0, 0, 0.4);
vertical-align: middle;
}
.change-up {
color: darkgreen;
}
.change-up:after {
content: '\25b2';
}
.change-down {
color: darkred;
}
.change-down:after {
content: '\25bc';
}
.cell-rating {
font-size: 12px;
}
.wj-flexgrid .wj-detail {
padding: 4px 16px;
}
.wj-detail h3 {
margin: 10px 0;
}
import { Injectable } from '@angular/core';
import * as wjcCore from '@mescius/wijmo';
import * as wjcGrid from '@mescius/wijmo.grid';
import * as wjcGridPdf from '@mescius/wijmo.grid.pdf';
import * as wjcGridXlsx from '@mescius/wijmo.grid.xlsx';
import * as wjcPdf from '@mescius/wijmo.pdf';
import * as wjcXlsx from '@mescius/wijmo.xlsx';
import { KeyValue, Country, Images } from './app.data';
//
const ExcelExportDocName = 'FlexGrid.xlsx';
const PdfExportDocName = 'FlexGrid.pdf';
const FakeColumn: wjcGrid.Column = new wjcGrid.Column();
const FakeRow: wjcGrid.Row = new wjcGrid.Row();
//
class Fonts {
static ZapfDingbatsSm = new wjcPdf.PdfFont('zapfdingbats', 8, 'normal', 'normal');
static ZapfDingbatsLg = new wjcPdf.PdfFont('zapfdingbats', 16, 'normal', 'normal');
}
//
export class IExcelExportContext {
exporting: boolean;
progress: number;
preparing: boolean;
}
//
@Injectable()
export class ExportService {
startExcelExport(flex: wjcGrid.FlexGrid, ctx: IExcelExportContext) {
if (ctx.preparing || ctx.exporting) {
return;
}
ctx.exporting = false;
ctx.progress = 0;
ctx.preparing = true;
wjcGridXlsx.FlexGridXlsxConverter.saveAsync(flex, {
includeColumnHeaders: true,
includeStyles: false,
formatItem: this._formatExcelItem.bind(this)
},
ExcelExportDocName,
() => {
console.log('Export to Excel completed');
this._resetExcelContext(ctx);
},
err => {
console.error(`Export to Excel failed: ${err}`);
this._resetExcelContext(ctx);
},
prg => {
if (ctx.preparing) {
ctx.exporting = true;
ctx.preparing = false;
}
ctx.progress = prg / 100.;
},
true
);
console.log('Export to Excel started');
}
cancelExcelExport(ctx: IExcelExportContext) {
wjcGridXlsx.FlexGridXlsxConverter.cancelAsync(() => {
console.log('Export to Excel canceled');
this._resetExcelContext(ctx);
});
}
exportToPdf(flex: wjcGrid.FlexGrid, options: any) {
wjcGridPdf.FlexGridPdfConverter.export(flex, PdfExportDocName, {
maxPages: 100,
exportMode: wjcGridPdf.ExportMode.All,
scaleMode: wjcGridPdf.ScaleMode.ActualSize,
documentOptions: {
pageSettings: {
layout: wjcPdf.PdfPageOrientation.Landscape
},
header: {
declarative: {
text: '\t&[Page]\\&[Pages]'
}
},
footer: {
declarative: {
text: '\t&[Page]\\&[Pages]'
}
}
},
styles: {
cellStyle: {
backgroundColor: '#ffffff',
borderColor: '#c6c6c6'
},
altCellStyle: {
backgroundColor: '#f9f9f9'
},
groupCellStyle: {
backgroundColor: '#dddddd'
},
headerCellStyle: {
backgroundColor: '#eaeaea'
},
// Highlight Invalid Cells
errorCellStyle: {
backgroundColor: 'rgba(255, 0, 0, 0.3)'
}
},
customCellContent: false,
formatItem: (e: wjcGridPdf.PdfFormatItemEventArgs) => this._formatPdfItem(e, options)
});
}
private _formatExcelItem(e: wjcGridXlsx.XlsxFormatItemEventArgs) {
const panel = e.panel;
if (panel.cellType !== wjcGrid.CellType.Cell) {
return;
}
// highlight invalid cells
if (panel.grid._getError(panel, e.row, e.col)) {
const fill = new wjcXlsx.WorkbookFill();
fill.color = '#ff0000';
e.xlsxCell.style.fill = fill;
}
}
private _resetExcelContext(ctx: IExcelExportContext) {
ctx.exporting = false;
ctx.progress = 0;
ctx.preparing = false;
}
private _formatPdfItem(e: wjcGridPdf.PdfFormatItemEventArgs, options: any) {
const panel = e.panel;
if (panel.cellType !== wjcGrid.CellType.Cell) {
return;
}
switch (panel.columns[e.col].binding) {
case 'countryId':
this._formatPdfCountryCell(e, options.countryMap);
break;
case 'colorId':
this._formatPdfColorCell(e, options.colorMap);
break;
case 'change':
this._formatPdfChangeCell(e);
break;
case 'history':
/*** Version #1: get grid cell produced before by a cell template ***/
// const cell = e.getFormattedCell();
// this._formatPdfHistoryCell(e, cell);
/*** Version #2: create fake cell from a cell template ***/
const history = e.panel.getCellData(e.row, e.col, false);
const cell = this._createCellFromCellTemplate(options.historyCellTemplate, history);
this._formatPdfHistoryCell(e, cell);
break;
case 'rating':
this._formatPdfRatingCell(e);
break;
}
}
private _formatPdfCountryCell(e: wjcGridPdf.PdfFormatItemEventArgs, countryMap: wjcGrid.DataMap<number, Country>) {
e.drawBackground(e.style.backgroundColor);
// check whether country exists
const countryName = e.data;
if (this._isCountryExist(countryName, countryMap)) {
// bound rectangle of cell's content area
const contentRect = e.contentRect;
// draw flag image
const image = e.canvas.openImage(Images[countryName.toLowerCase()]);
const imageTop = contentRect.top + (contentRect.height - image.height) / 2;
e.canvas.drawImage(image, contentRect.left, imageTop);
// draw country name
e.canvas.drawText(countryName, contentRect.left + image.width + 3, e.textTop);
}
// cancel standard cell content drawing
e.cancel = true;
}
private _formatPdfColorCell(e: wjcGridPdf.PdfFormatItemEventArgs, colorMap: wjcGrid.DataMap<number, KeyValue>) {
e.drawBackground(e.style.backgroundColor);
// check whether color exists
const colorName = e.data;
if (this._isColorExist(colorName, colorMap)) {
// bound rectangle of cell's content area
const contentRect = e.contentRect;
// draw color indicator
const imageHeight = Math.min(10, contentRect.height);
const imageWidth = 1.33 * imageHeight;
const imageTop = contentRect.top + (contentRect.height - imageHeight) / 2;
e.canvas.paths
.rect(contentRect.left, imageTop, imageWidth, imageHeight)
.fillAndStroke(wjcCore.Color.fromString(colorName), wjcCore.Color.fromString('gray'));
// draw color name
e.canvas.drawText(colorName, contentRect.left + imageWidth + 3, e.textTop);
}
// cancel standard cell content drawing
e.cancel = true;
}
private _formatPdfChangeCell(e: wjcGridPdf.PdfFormatItemEventArgs) {
e.drawBackground(e.style.backgroundColor);
// get change value and text
const cellData = e.panel.getCellData(e.row, e.col, false);
let change = 0;
let changeText = '';
if (wjcCore.isNumber(cellData)) {
change = cellData;
changeText = wjcCore.Globalize.formatNumber(change, 'c');
} else if (!wjcCore.isUndefined(cellData) && cellData !== null) {
changeText = wjcCore.changeType(cellData, wjcCore.DataType.String);
}
// determine whether change is positive or negative
let changeIndicator = '';
let changeColor = e.style.color;
if (change > 0) {
changeIndicator = '\x73' // ▲
changeColor = 'darkgreen';
} else if (change < 0) {
changeIndicator = '\x74' // ▼
changeColor = 'darkred';
}
// draw change indicator
let indent = 10;
e.canvas.drawText(changeIndicator, e.contentRect.right - indent, e.contentRect.top + indent, {
brush: changeColor,
font: Fonts.ZapfDingbatsSm
});
// draw change text
indent += 3;
e.canvas.drawText(changeText, e.contentRect.left, e.textTop, {
brush: changeColor,
align: wjcPdf.PdfTextHorizontalAlign.Right,
width: e.contentRect.width - indent
});
// cancel standard cell content drawing
e.cancel = true;
}
private _formatPdfHistoryCell(e: wjcGridPdf.PdfFormatItemEventArgs, cell: HTMLElement) {
e.drawBackground(e.style.backgroundColor);
// draw history svg
const svgUrl = this._getHistorySvgDataUrlFromCell(cell, e.clientRect.width, e.clientRect.height);
if (svgUrl) {
let cr = e.contentRect;
e.canvas.drawSvg(svgUrl, cr.left + 2, cr.top + 2, { width: cr.width - 4, height: cr.height - 4 });
}
// cancel standard cell content drawing
e.cancel = true;
}
private _getHistorySvgDataUrlFromCell(cell: HTMLElement, width: number, height: number): string {
let dataUrl: string = null;
// extract SVG from provided cell
const svg = cell.getElementsByTagName('svg')[0];
if (svg) {
const clone = <any>svg.cloneNode(true);
clone.setAttribute('version', '1.1');
clone.setAttributeNS('http://www.w3.org/2000/xmlns/', 'xmlns', 'http://www.w3.org/2000/svg');
clone.style.overflow = 'visible';
clone.style.stroke = '#376092';
clone.style.fill = '#376092';
const s = document.createElement('style');
s.setAttribute('type', 'text/css');
s.innerHTML = `<![CDATA[
line {
stroke-width: 2;
}
circle {
stroke-width: 0;
stroke-opacity: 0;
}
.wj-marker {
fill: #d00000;
opacity: 1;
}
]]>`;
const defs = document.createElement('defs');
defs.appendChild(s);
clone.insertBefore(defs, clone.firstChild);
const outer = document.createElement('div');
outer.appendChild(clone);
dataUrl = 'data:image/svg+xml;base64,' + btoa(unescape(encodeURIComponent(outer.innerHTML)));
}
return dataUrl;
}
private _formatPdfRatingCell(e: wjcGridPdf.PdfFormatItemEventArgs) {
e.drawBackground(e.style.backgroundColor);
// check whether rating is defined
let rating = wjcCore.changeType(e.data, wjcCore.DataType.Number);
if (wjcCore.isInt(rating)) {
const ratingIndicator = '\x48' // ★
const ratingNormalColor = wjcCore.Color.fromRgba(255, 165, 0, 1); // orange
const ratingLightColor = wjcCore.Color.fromRgba(255, 165, 0, 0.2);
// draw rating indicators
const indent = 16;
const count = 5;
const width = count * indent;
const y = e.clientRect.top + indent;
let x = e.contentRect.left + (e.contentRect.width - width) / 2;
rating = wjcCore.clamp(rating, 1, count);
for (let i = 0; i < count; i++) {
e.canvas.drawText(ratingIndicator, x, y, {
brush: (i < rating) ? ratingNormalColor : ratingLightColor,
font: Fonts.ZapfDingbatsLg,
height: e.clientRect.height
});
x += indent;
}
}
// cancel standard cell content drawing
e.cancel = true;
}
private _isCountryExist(countryName: any, countryMap: wjcGrid.DataMap<number, Country>) {
const countryId = countryMap.getKeyValue(countryName);
if (wjcCore.isUndefined(countryId) || countryId === null) {
return false;
}
if (countryId === Country.NotFound.id) {
return false;
}
return true;
}
private _isColorExist(colorName: any, colorMap: wjcGrid.DataMap<number, KeyValue>) {
const colorId = colorMap.getKeyValue(colorName);
if (wjcCore.isUndefined(colorId) || colorId === null) {
return false;
}
if (colorId === KeyValue.NotFound.key) {
return false;
}
return true;
}
private _createCellFromCellTemplate(cellTemplate: wjcGrid.ICellTemplateFunction, data: any) {
const cell = document.createElement('div');
cellTemplate({
col: FakeColumn,
row: FakeRow,
value: data,
item: null,
text: null
}, cell);
return cell;
}
}
import * as wjcCore from '@mescius/wijmo';
export interface IValidator {
validate(name: string, value: any): string;
}
export class RequiredValidator implements IValidator {
validate(name: string, value: any): string {
const message = name + ' is required';
if (wjcCore.isUndefined(value)) {
return message;
}
const str = wjcCore.changeType(value, wjcCore.DataType.String);
if (wjcCore.isNullOrWhiteSpace(str)) {
return message;
}
return '';
}
}
export abstract class MinValueValidator<TValue> implements IValidator {
readonly minValue: TValue;
readonly message: string;
readonly format: string;
constructor(minValue: TValue, message: string = '{0} can\'t be less than {1}', format: string = null) {
this.minValue = minValue;
this.message = message;
this.format = format;
}
validate(name: string, value: any): string {
if (value < this.minValue) {
return wjcCore.format(this.message, {
0: name,
1: this._formatValue(this.minValue)
});
}
return '';
}
protected abstract _formatValue(value: TValue): string;
}
export abstract class MaxValueValidator<TValue> implements IValidator {
readonly maxValue: TValue;
readonly message: string;
readonly format: string;
constructor(maxValue: TValue, message: string = '{0} can\'t be greater than {1}', format: string = null) {
this.maxValue = maxValue;
this.message = message;
this.format = format;
}
validate(name: string, value: any): string {
if (value > this.maxValue) {
return wjcCore.format(this.message, {
0: name,
1: this._formatValue(this.maxValue)
});
}
return '';
}
protected abstract _formatValue(value: TValue): string;
}
export class MinNumberValidator extends MinValueValidator<number> {
constructor(minValue: number, message: string = '{0} can\'t be less than {1}', format: string = 'n') {
super(minValue, message, format);
}
protected _formatValue(value: number): string {
return wjcCore.Globalize.formatNumber(value, this.format);
}
}
export class MaxNumberValidator extends MaxValueValidator<number> {
constructor(maxValue: number, message: string = '{0} can\'t be greater than {1}', format: string = 'n') {
super(maxValue, message, format);
}
protected _formatValue(value: number): string {
return wjcCore.Globalize.formatNumber(value, this.format);
}
}
export class MinDateValidator extends MinValueValidator<Date> {
constructor(minValue: Date, message: string = '{0} can\'t be less than {1}', format: string = 'MM/dd/yyyy') {
super(minValue, message, format);
}
protected _formatValue(value: Date): string {
return wjcCore.Globalize.formatDate(value, this.format);
}
}
export class MaxDateValidator extends MaxValueValidator<Date> {
constructor(maxValue: Date, message: string = '{0} can\'t be greater than {1}', format: string = 'MM/dd/yyyy') {
super(maxValue, message, format);
}
protected _formatValue(value: Date): string {
return wjcCore.Globalize.formatDate(value, this.format);
}
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
target: 'ES2022',
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
typescript: {
exports: 'ts',
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm',
},
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/latest/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/',
'agpcdn:': 'https://cdn.jsdelivr.net/npm/'
},
packageConfigPaths: ['/node_modules/*/package.json', '/node_modules/@angular/*/package.json', '/node_modules/@mescius/*/package.json'],
map: {
'core-js': 'agpcdn:core-js@2.6.12/client/shim.min.js',
'typescript': 'agpcdn:typescript@5.9.3/lib/typescript.min.js',
rxjs: 'agpcdn:rxjs@7.8.1/dist/bundles/rxjs.umd.min.js',
'systemjs-plugin-css': 'agpcdn:systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.angular2.chart.analytics': 'cdn:@mescius/wijmo.angular2.chart.analytics/index.js',
'@mescius/wijmo.angular2.chart.animation': 'cdn:@mescius/wijmo.angular2.chart.animation/index.js',
'@mescius/wijmo.angular2.chart.annotation': 'cdn:@mescius/wijmo.angular2.chart.annotation/index.js',
'@mescius/wijmo.angular2.chart.finance.analytics': 'cdn:@mescius/wijmo.angular2.chart.finance.analytics/index.js',
'@mescius/wijmo.angular2.chart.finance': 'cdn:@mescius/wijmo.angular2.chart.finance/index.js',
'@mescius/wijmo.angular2.chart.hierarchical': 'cdn:@mescius/wijmo.angular2.chart.hierarchical/index.js',
'@mescius/wijmo.angular2.chart.interaction': 'cdn:@mescius/wijmo.angular2.chart.interaction/index.js',
'@mescius/wijmo.angular2.chart.radar': 'cdn:@mescius/wijmo.angular2.chart.radar/index.js',
'@mescius/wijmo.angular2.chart.map': 'cdn:@mescius/wijmo.angular2.chart.map/index.js',
'@mescius/wijmo.angular2.chart': 'cdn:@mescius/wijmo.angular2.chart/index.js',
'@mescius/wijmo.angular2.core': 'cdn:@mescius/wijmo.angular2.core/index.js',
'@mescius/wijmo.angular2.gauge': 'cdn:@mescius/wijmo.angular2.gauge/index.js',
'@mescius/wijmo.angular2.grid.detail': 'cdn:@mescius/wijmo.angular2.grid.detail/index.js',
'@mescius/wijmo.angular2.grid.filter': 'cdn:@mescius/wijmo.angular2.grid.filter/index.js',
'@mescius/wijmo.angular2.grid.grouppanel': 'cdn:@mescius/wijmo.angular2.grid.grouppanel/index.js',
'@mescius/wijmo.angular2.grid.search': 'cdn:@mescius/wijmo.angular2.grid.search/index.js',
'@mescius/wijmo.angular2.grid.multirow': 'cdn:@mescius/wijmo.angular2.grid.multirow/index.js',
'@mescius/wijmo.angular2.grid.sheet': 'cdn:@mescius/wijmo.angular2.grid.sheet/index.js',
'@mescius/wijmo.angular2.grid.transposed': 'cdn:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'cdn:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
'@mescius/wijmo.angular2.grid': 'cdn:@mescius/wijmo.angular2.grid/index.js',
'@mescius/wijmo.angular2.input': 'cdn:@mescius/wijmo.angular2.input/index.js',
'@mescius/wijmo.angular2.olap': 'cdn:@mescius/wijmo.angular2.olap/index.js',
'@mescius/wijmo.angular2.viewer': 'cdn:@mescius/wijmo.angular2.viewer/index.js',
'@mescius/wijmo.angular2.nav': 'cdn:@mescius/wijmo.angular2.nav/index.js',
'@mescius/wijmo.angular2.directivebase': 'cdn:@mescius/wijmo.angular2.directivebase/index.js',
'@mescius/wijmo.angular2.barcode.common': 'cdn:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'cdn:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'cdn:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
jszip: 'agpcdn:jszip@3.10.1/dist/jszip.min.js',
'@angular/core': 'pcdn:@angular/core@21.1.0/fesm2022/core.mjs',
'@angular/core/primitives/di': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-di.mjs',
'@angular/core/primitives/signals': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-signals.mjs',
'@angular/core/primitives/event-dispatch': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-event-dispatch.mjs',
'@angular/common': 'pcdn:@angular/common@21.1.0/fesm2022/common.mjs',
'@angular/common/http': 'pcdn:@angular/common@21.1.0/fesm2022/http.mjs',
'@angular/compiler': 'pcdn:@angular/compiler@21.1.0/fesm2022/compiler.mjs',
'@angular/platform-browser': 'pcdn:@angular/platform-browser@21.1.0/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'pcdn:@angular/platform-browser-dynamic@21.1.0/fesm2022/platform-browser-dynamic.mjs',
'@angular/router': 'pcdn:@angular/router@21.1.0/fesm2022/router.mjs',
'@angular/forms': 'pcdn:@angular/forms@21.1.0/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
'./src': {
defaultExtension: 'ts',
},
node_modules: {
defaultExtension: 'js',
},
wijmo: {
defaultExtension: 'js',
},
},
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import ReactDOM from 'react-dom/client';
import React, { useEffect, useRef, useState } from 'react';
import useEvent from 'react-use-event-hook';
import '@mescius/wijmo.touch';
import * as wjCore from '@mescius/wijmo';
import { InputDate, InputTime } from '@mescius/wijmo.input';
import { CellMaker, SparklineMarkers } from '@mescius/wijmo.grid.cellmaker';
import { DataMap } from '@mescius/wijmo.grid';
import { FlexGrid, FlexGridColumn, FlexGridCellTemplate } from '@mescius/wijmo.react.grid';
import { FlexGridFilter } from '@mescius/wijmo.react.grid.filter';
import { FlexGridSearch } from '@mescius/wijmo.react.grid.search';
import { GroupPanel as FlexGridGroupPanel } from '@mescius/wijmo.react.grid.grouppanel';
import './app.css';
import { DataService, Country, KeyValue } from './data';
import { ExportService } from './export';
const dataService = new DataService();
const exportService = new ExportService();
const buildDataMap = (items) => {
const map = [];
for (let i = 0; i < items.length; i++) {
map.push({ key: i, value: items[i] });
}
return new DataMap(map, 'key', 'value');
};
function App() {
const [count, setCount] = useState(0);
const [itemsCount, setItemsCount] = useState(500);
const [isExcelPreparing, setIsExcelPreparing] = useState(false);
const [isExcelExporting, setIsExcelExporting] = useState(false);
const [excelProgress, setExcelProgress] = useState(0);
const flex = useRef(null);
const theGrid = useRef(null);
const theSearch = useRef(null);
const lastId = useRef(itemsCount);
const productMap = useRef(buildDataMap(dataService.getProducts()));
const countryMap = useRef(new DataMap(dataService.getCountries(), 'id', 'name'));
const colorMap = useRef(buildDataMap(dataService.getColors()));
const dateEditor = useRef(new InputDate(document.createElement('div'), {
format: 'MM/dd/yyyy',
isRequired: false
}));
const timeEditor = useRef(new InputTime(document.createElement('div'), {
format: 'HH:mm',
isRequired: false
}));
const historyCellTemplate = useRef(CellMaker.makeSparkline({
markers: SparklineMarkers.High | SparklineMarkers.Low,
maxPoints: 25,
label: 'price history',
}));
const ratingCellTemplate = useRef(CellMaker.makeRating({
range: [1, 5],
label: 'rating'
}));
const forceUpdate = () => setCount(count + 1);
useEffect(() => {
exportService.cancelExcelExport();
// connect search box and grid
theSearch.current.control.grid = theGrid.current.control;
}, []);
const countryCellTemplate = useEvent((ctx) => {
const country = countryMap.current.getDataItem(ctx.item.countryId) || Country.NotFound;
return (<React.Fragment>
<span className={`flag-icon flag-icon-${country.flag}`}/>
{' '}{country.name}{' '}
</React.Fragment>);
});
const colorCellTemplate = useEvent((ctx) => {
const color = (colorMap.current.getDataItem(ctx.item.colorId) || KeyValue.NotFound).value;
return (<React.Fragment>
<span className="color-tile" style={{ background: color }}/>
{' '}{color}{' '}
</React.Fragment>);
});
const changeCellTemplate = useEvent((ctx) => {
const change = ctx.item.change;
let cssClass = '';
let displayValue = '';
if (wjCore.isNumber(change)) {
if (change > 0) {
cssClass = 'change-up';
}
else if (change < 0) {
cssClass = 'change-down';
}
displayValue = wjCore.Globalize.formatNumber(change, 'c');
}
else if (!wjCore.isUndefined(change) && change !== null) {
displayValue = wjCore.changeType(change, wjCore.DataType.String);
}
return (<span className={cssClass}>
{displayValue}
</span>);
});
const gridInitialized = useEvent((ctl) => {
ctl.itemsSource = createItemsSource(itemsCount);
flex.current = ctl;
forceUpdate();
});
const itemsCountChanged = (e) => {
const itemsCount = parseInt(e.target.value);
setItemsCount(itemsCount);
flex.current.itemsSource.collectionChanged.removeAllHandlers();
lastId.current = itemsCount;
flex.current.itemsSource = createItemsSource(itemsCount);
};
const exportToExcel = () => {
const preparing = isExcelPreparing;
const exporting = isExcelExporting;
const resetState = () => {
setIsExcelPreparing(false);
setIsExcelExporting(false);
setExcelProgress(0);
};
if (!preparing && !exporting) {
setIsExcelPreparing(true);
exportService.startExcelExport(flex.current, () => {
console.log('Export to Excel completed');
resetState();
}, (err) => {
console.error(`Export to Excel failed: ${err}`);
resetState();
}, (prg) => {
setIsExcelPreparing(false);
setIsExcelExporting(false);
setExcelProgress(prg);
});
console.log('Export to Excel started');
}
else {
exportService.cancelExcelExport(() => {
console.log('Export to Excel canceled');
resetState();
});
}
};
const exportToPdf = () => {
exportService.exportToPdf(flex.current, {
countryMap: countryMap.current,
colorMap: colorMap.current,
historyCellTemplate: historyCellTemplate.current,
});
};
const createItemsSource = (counter) => {
const data = dataService.getData(counter || 10);
const view = new wjCore.CollectionView(data, {
getError: (item, prop) => {
const displayName = flex.current.columns.getColumn(prop).header;
return dataService.validate(item, prop, displayName);
}
});
view.collectionChanged.addHandler((s, e) => {
// initializes new added item with a history data
if (e.action === wjCore.NotifyCollectionChangedAction.Add) {
e.item.history = dataService.getHistoryData();
e.item.id = lastId.current;
lastId.current++;
}
});
return view;
};
return (<main className="container-fluid">
<div className="row">
<div className="toolbar-item col-sm-3 col-md-5">
<FlexGridSearch ref={theSearch} placeholder="Search" cssMatch=""/>
</div>
<div className="toolbar-item col-sm-3 col-md-3">
<div className="input-group">
<span className="input-group-addon">Items:</span>
<select className="form-control" value={itemsCount} onChange={itemsCountChanged} aria-label="Data Size">
<option value="5">5</option>
<option value="50">50</option>
<option value="500">500</option>
<option value="5000">5,000</option>
<option value="50000">50,000</option>
<option value="100000">100,000</option>
</select>
</div>
</div>
<div className="toolbar-item col-sm-3 col-md-2">
<button className="btn btn-default btn-block" disabled={isExcelPreparing} onClick={exportToExcel}>
{isExcelExporting ? `Cancel (${excelProgress}% done)` : 'Export To Excel'}
</button>
</div>
<div className="toolbar-item col-sm-3 col-md-2">
<button className="btn btn-default btn-block" onClick={exportToPdf}>Export To PDF</button>
</div>
</div>
<FlexGridGroupPanel grid={flex.current} placeholder={"Drag columns here to create groups"}/>
<FlexGrid ref={theGrid} autoGenerateColumns={false} allowAddNew allowDelete allowPinning="SingleColumn" newRowAtTop showMarquee selectionMode="MultiRange" validateEdits={false} initialized={gridInitialized}>
<FlexGridFilter filterColumns={['id', 'date', 'time', 'countryId', 'productId', 'colorId', 'price', 'change', 'discount', 'rating', 'active']}/>
<FlexGridColumn header="ID" binding="id" width={70} isReadOnly={true}/>
<FlexGridColumn header="Date" binding="date" format="MMM d yyyy" isRequired={false} width={130} editor={dateEditor.current}/>
<FlexGridColumn header="Country" binding="countryId" dataMap={countryMap.current} width={145}>
<FlexGridCellTemplate cellType="Cell" template={countryCellTemplate}/>
</FlexGridColumn>
<FlexGridColumn header="Price" binding="price" format="c" isRequired={false} width={100}/>
<FlexGridColumn header="History" binding="history" align="center" width={180} allowSorting={false} cellTemplate={historyCellTemplate.current}/>
<FlexGridColumn header="Change" binding="change" align="right" width={115}>
<FlexGridCellTemplate cellType="Cell" template={changeCellTemplate}/>
</FlexGridColumn>
<FlexGridColumn header="Rating" binding="rating" align="center" width={180} cssClass="cell-rating" cellTemplate={ratingCellTemplate.current}/>
<FlexGridColumn header="Time" binding="time" format="HH:mm" isRequired={false} width={95} editor={timeEditor.current}>
</FlexGridColumn>
<FlexGridColumn header="Color" binding="colorId" dataMap={colorMap.current} width={145}>
<FlexGridCellTemplate cellType="Cell" template={colorCellTemplate}/>
</FlexGridColumn>
<FlexGridColumn header="Product" binding="productId" dataMap={productMap.current} width={145}/>
<FlexGridColumn header="Discount" binding="discount" format="p0" width={130}/>
<FlexGridColumn header="Active" binding="active" width={100}/>
</FlexGrid>
</main>);
}
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Wijmo FlexGrid Overview</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.19.40/dist/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
@import url('https://cdnjs.cloudflare.com/ajax/libs/flag-icon-css/3.1.0/css/flag-icon.css');
body {
font-size: 1.5em;
font-family: -apple-system, BlinkMacSystemFont, "Segoe UI Light", Roboto, Oxygen-Sans, Ubuntu, Cantarell, "Helvetica Neue", sans-serif;
}
.toolbar-item {
margin-bottom: 6px;
}
.wj-flexgridsearch {
width: 100%;
}
.wj-flexgrid {
height: 330px;
}
.wj-flexgrid .wj-cell {
padding: 7px;
border: none;
}
.wj-cell.wj-state-invalid:not(.wj-header)::after {
top: -14px;
border: 14px solid transparent;
border-right-color: red;
}
.flag-icon {
box-shadow: 1px 1px 4px rgba(0, 0, 0, 0.4);
}
.color-tile {
display: inline-block;
position: relative;
width: 1em;
height: 1em;
border-radius: 50%;
box-shadow: 1px 1px 4px rgba(0, 0, 0, 0.4);
vertical-align: middle;
}
.change-up {
color: darkgreen;
}
.change-up:after {
content: '\25b2';
margin-left: 0.5em;
}
.change-down {
color: darkred;
}
.change-down:after {
content: '\25bc';
margin-left: 0.5em;
}
.cell-rating {
font-size: 12px;
}
.wj-flexgrid .wj-detail {
padding: 4px 16px;
}
.wj-detail h3 {
margin: 10px 0;
}
import * as wjcCore from '@mescius/wijmo';
import { RequiredValidator, MinNumberValidator, MinDateValidator, MaxNumberValidator, MaxDateValidator } from './validation';
export class KeyValue {
}
KeyValue.NotFound = { key: -1, value: '' };
export class Country {
}
Country.NotFound = { id: -1, name: '', flag: '' };
export class DataService {
constructor() {
this._products = ['Widget', 'Gadget', 'Doohickey'];
this._colors = ['Black', 'White', 'Red', 'Green', 'Blue'];
this._countries = [
{ id: 0, name: 'US', flag: 'us' },
{ id: 1, name: 'Germany', flag: 'de' },
{ id: 2, name: 'UK', flag: 'gb' },
{ id: 3, name: 'Japan', flag: 'jp' },
{ id: 4, name: 'Italy', flag: 'it' },
{ id: 5, name: 'Greece', flag: 'gr' }
];
this._validationConfig = {
'date': [
new RequiredValidator(),
new MinDateValidator(new Date('2000-01-01T00:00:00')),
new MaxDateValidator(new Date('2100-01-01T00:00:00'))
],
'time': [
new RequiredValidator(),
new MinDateValidator(new Date('2000-01-01T00:00:00')),
new MaxDateValidator(new Date('2100-01-01T00:00:00'))
],
'productId': [
new RequiredValidator(),
new MinNumberValidator(0, `{0} can't be less than {1} (${this._products[0]})`),
new MaxNumberValidator(this._products.length - 1, `{0} can't be greater than {1} (${this._products[this._products.length - 1]})`)
],
'countryId': [
new RequiredValidator(),
new MinNumberValidator(0, `{0} can't be less than {1} (${this._countries[0].name})`),
new MaxNumberValidator(this._countries.length - 1, `{0} can't be greater than {1} (${this._countries[this._countries.length - 1].name})`)
],
'colorId': [
new RequiredValidator(),
new MinNumberValidator(0, `{0} can't be less than {1} (${this._colors[0]})`),
new MaxNumberValidator(this._colors.length - 1, `{0} can't be greater than {1} (${this._colors[this._colors.length - 1]})`)
],
'price': [
new RequiredValidator(),
new MinNumberValidator(0, `Price can't be a negative value`)
]
};
}
getCountries() {
return this._countries;
}
getProducts() {
return this._products;
}
getColors() {
return this._colors;
}
getHistoryData() {
return this._getRandomArray(25, 100);
}
getData(count) {
const data = [];
const dt = new Date();
const year = dt.getFullYear();
const itemsCount = Math.max(count, 5);
// add items
for (let i = 0; i < itemsCount; i++) {
const item = this._getItem(i, year);
data.push(item);
}
// set invalid data to demonstrate errors visualization
data[1].price = -2000;
data[2].date = new Date('1970-01-01T00:00:00');
data[4].time = undefined;
data[4].price = -1000;
return data;
}
validate(item, prop, displayName) {
const validators = this._validationConfig[prop];
if (wjcCore.isUndefined(validators)) {
return '';
}
const value = item[prop];
for (let i = 0; i < validators.length; i++) {
const validationError = validators[i].validate(displayName, value);
if (!wjcCore.isNullOrWhiteSpace(validationError)) {
return validationError;
}
}
}
_getItem(i, year) {
const date = new Date(year, i % 12, 25, i % 24, i % 60, i % 60);
const countryIndex = this._getRandomIndex(this._countries);
const productIndex = this._getRandomIndex(this._products);
const colorIndex = this._getRandomIndex(this._colors);
const item = {
id: i,
date: date,
time: new Date(date.getTime() + Math.random() * 30 * (24 * 60 * 60 * 1000)),
countryId: this._countries[countryIndex].id,
productId: productIndex,
colorId: colorIndex,
price: wjcCore.toFixed(Math.random() * 10000 + 5000, 2, true),
change: wjcCore.toFixed(Math.random() * 1000 - 500, 2, true),
history: this.getHistoryData(),
discount: wjcCore.toFixed(Math.random() / 4, 2, true),
rating: this._getRating(),
active: i % 4 == 0,
size: Math.floor(100 + Math.random() * 900),
weight: Math.floor(100 + Math.random() * 900),
quantity: Math.floor(Math.random() * 10),
description: "Across all our software products and services, our focus is on helping our customers achieve their goals. Our key principles – thoroughly understanding our customers' business objectives, maintaining a strong emphasis on quality, and adhering to the highest ethical standards – serve as the foundation for everything we do."
};
return item;
}
_getRating() {
return Math.ceil(Math.random() * 5);
}
_getRandomIndex(arr) {
return Math.floor(Math.random() * arr.length);
}
_getRandomArray(len, maxValue) {
const arr = [];
for (let i = 0; i < len; i++) {
arr.push(Math.floor(Math.random() * maxValue));
}
return arr;
}
}
export const Images = {
"germany": "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAALCAIAAAD5gJpuAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAadEVYdFNvZnR3YXJlAFBhaW50Lk5FVCB2My41LjExR/NCNwAAAhBJREFUKFNj8PFx9vG08nG38PGycXOzcnA0s7c3tLfXx4UY3N2tdu3aCEQ7dqzftm3t5s0rN2xYvnbt4lWr5i9bNnvRounz5k6aNatv2rTOiRNbQBo8PW2Aqpuam+vq6qqqqkpLS/Pz8zMzMpOSkqKjo0NCQnx9fV1dXe1sbXt760Ea0jxtTu1YP7+ubnZV1fSSksn5+X0ZGZ2Jic3R0XXBwRU+3oWuLjk2Nqlmpks7q0Aa9rmY/t265m9l5Z/i4t95eb8yMn4mJv6IivoWFPzF2/uzi8tHG5sPxqbvdHU/t5StBGrYa6//Z9NKkOrcvF9paT8TEr5HRn4LCvri5fXZ2Rmo+r2x8TsdnTcqqp/qC1YANewBali/9HduLkh1fDxIdWDgF0/PT05OH62t3xsZvdPRfq2i8kpO7mNN9lKghu2V+n+uLvm1Kfvn+pTvq2K/Lg37ssj/01z3jzMd30+xfDfB6HW31qt2lRdNsh+25cwFati2XP/3x0U/n2V8f5L49VHUlwfBn+56f7zt+v6m7dvr5q+v6L+8qPnivNKzs7LvH+TObgFqWKj/6+3cn69n/Xw95cfLid+fd3992v71SdOXR/WfH1R9ulf28W7xhzv5729nv7+VObdSn2Fdn/62bv0trfqbO/TX1Ouvqtdf2au/ulV/ZZP+4lb9BfX682r0F9fpLyzTX1ipP7lYHwAoyRFNzrKSzQAAAABJRU5ErkJggg==",
"greece": "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAALCAIAAAD5gJpuAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAadEVYdFNvZnR3YXJlAFBhaW50Lk5FVCB2My41LjExR/NCNwAAAgJJREFUKFNF0d1LU3EYB/AnuhgG0WXddBFdRYREDQkT/4GkuxKJXojo2oIuoosMwUJhtJBJJmsOM1diJGtNm869tNNx0xWbNXE6z17OOds523n/nXP21nEL+vK9/HzhgQeO9oaNJlvp6Al2dIfAvAadq3DGB6e9cNIDxxfh2AKY5uHQB4DZg8HVh8lms9loNPoeJPsGE5peU7UaMqpWEdIVpMmKKslIkNCvrTQQBNHW7dTr9UCU8a8zK3jpG1ZcjtDeMO0JUe4AuYLTQ8Oxg8E/29JGrLNZy8z+6HTmuX13+E366cTOk/Htx9bU2HQaTjjA1B00Lmnr3vs/e+7FRVkXJU0QVV5EnKBUOJmtSExZKHMShm/BYXPwymDC0LVazdCX725eurPRdTtmvhm7cCN6fmC9sx8/d/3H2WtY162o6dQcUBRj0Gq1qutVTdNVVUNIUxRVlpEkyaIo8YLIcQLH8YIgxuMJsLkym78r4Tgb2mACsZI/WlzFiz6MXo5QS2Hya6jwJVhwr+UX/TkfRg49w6D/Eeb9zs4tke88Bac7//ZzdmqBeD2/b3Ptjb/ftc7sWJzbY47UC/ufyY/pIxcdkNrjy7zKcogtoxKr0KxMMRJVFAu0kKf4HMllCxyRrxA5NpNlXZ8i8P+R0HokOAHsAJMANoBXAC8BLACjrY4AjPwFh3JwhG+uVAQAAAAASUVORK5CYII=",
"italy": "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAALCAIAAAD5gJpuAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAadEVYdFNvZnR3YXJlAFBhaW50Lk5FVCB2My41LjExR/NCNwAAAX5JREFUKFNdzL1LAnEcx/HPLpSgSy225KIgCinUcA06iKDCXXSSIhUUtAhFijk0SEhj/0ZQJGVhz2GkBv4FIiKHRESE9+D5kNLvd07dl8/4en+BE+BYWw7Iot1uC4LQarWazWaj0ajX6wogAR3gB/gGuSNk3jNk6Uo6VU6Nx+PRiGz0q91wOBxEo/3V1R7LqsHgFw2OSXAQf4pHH6KR2wihE03pYNDv93sej+p0du121e//pEEO5DfR/F2Eu+H0utej2mZTrNau1/sxCZKVJH/Pc0UuXAjrtapSPT8vz80pDKMFWey+7bFFNnQdClwG9LrbpdpikWZn5aWlNg0OkXhNhG5C/iu/78Kn14pC9cyMaDbLbrdAgwx2SjtU533LZ4xey/JEi0aj5HI1aZDC1vOWN+9lzpnF00W9liTRZOpMT3UMBtHh0IIE1h83YvcxvshzhZVJ8K9ZWBBdLqJFu71Bg31gG9gE1gAWtVqtWq2Wy+VSqfSiXQsgjwmlA/4AQZc4Q1AkNCsAAAAASUVORK5CYII=",
"japan": "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAALCAIAAAD5gJpuAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAadEVYdFNvZnR3YXJlAFBhaW50Lk5FVCB2My41LjExR/NCNwAAAVFJREFUKFNVkb2KwkAUhfMwVrHQwh/YWOgWKlin8kks3H0IF6xtbXyAPERQCaISgogEFRE1mcxPsrtnZrIuHobLFN+ZufdcI37VQ+l2u12VLpfL+Xw+Ho9hGB4Oh91+Lw0/St9/yjKcLFUSQnDOGWOU0iRJgiDIDTkr6SxznPTjUwwGfDZ7ooQQVN/3pSFnNT2dpr2e6HR46501GvRrpGlgqNvt9t8g6dMptW3RbvNWi1kNWqsl9TrZbMBEUYS6Wq0MjKhp2fJiIelmk1mWpMtlUizGjgMaGBye5xkIRNMCE4Yh73aZ9Uar1aRUIqYZm2bkeaDv9ztsy+VSGnQaeSDjMa1UcrpQiIZDTUO4SAPChgFoHh9mnExIvx/bdjQaPa5XoHgUwsV1XQOreYb9DDFBJmpK3T1eV38ow+sid1gNwkZ86/UamWBKtDGfz4FKue4vduTCcIOSUSoAAAAASUVORK5CYII=",
"uk": "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAALCAIAAAD5gJpuAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAadEVYdFNvZnR3YXJlAFBhaW50Lk5FVCB2My41LjExR/NCNwAAAepJREFUKFNjmDRz346rb6qnH0tpBqLDiY0Hbt59uza5cU1CHZDhmb3NI22HbcyGqMadcwLzq+ceZViy4tT/jav+/ft/++GXRRtuz19/B8j+P6Xnf18rkDFp4eXeuRdOnnj8r6vm39+fEzZdYEhqObjn5Lv/S5f/P7j3////bdOuAsn/qZn/ExKBdEnfpS+L1nzv7gay5626JGkyA6Rh4Ya7dROvPtx3/09TPUg1EMTE/A+PADFyM/+/eHHhzltHz+VFTUcEdScyAB0KcgMaCA397+cHZcMAUNmZay8Z1iTW/p/c8T8l5X98/P/IyP8hISClPj7/XF1/2dv/tLT8bmLyVU/vq7b2z2C3VnkrHDbY2v4xswCzQHJ///798/fP7z9/Tl59wWAft6lnzvmotB1Xrr7///bNz+R4kCojk9/6hmANf586Oe6fuVVCelZIwnoG4WwG87B1i9eDQuZzY92Hrq6YkmNA9h9t3V+a2kBXW9kv+fn//5dZc18kxDRNPccgmM4wefPlf//+fm+vOHrgdmHDwbyGw0AX/g3x+B3k/O/v3/C0baFxq7cfvvX3z4/XCb7ZRUsYquYdmOKS7Jy5SFBnDo/GZA7VCeevvWiVtmgRNzl95SWDeDGDaAGDcK6IYV3vnuuupnkAPExoqtcH3joAAAAASUVORK5CYII=",
"us": "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAALCAIAAAD5gJpuAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAadEVYdFNvZnR3YXJlAFBhaW50Lk5FVCB2My41LjExR/NCNwAAAeBJREFUKFNVkU1IVFEcxS/ozo0rN24EN2JiOYtyBoYGghEvQoItBCGof9FERB8zfSKOuHAZuEoqUltEkBCRplJpRi2MdhXFMIm+4TGfzud7M/e++7+v/q+k6HKW55zfvecyOPf+n86+A1gHWAVYAXiupy7izdMZ4AbwHeDbwBPAvYDr6kdvUf10FtZRKfXgDUopZtfQcSQdIRqNRp1Ur1uLi3NegNyDU0540jk24QRvy8AteeSGPBgVGI3iKcCREzgwgMGgvjv99Tdhg4qp6eiEY9s2uUulErmbY6JarZbL5WKxWCgUtB6zrOrW1iaje1MgNL7ffTjmdTdHK+z8axwexnAYAwHl86meHn1n/INHgFW6N7krlQq58/l80xUzlUqx48t/unO5XDabTafT31y9tPSEAiv3X6H/uvRdE4cui6ZLuyyyxgZfsgMv0O9XfX2qu1t1djrt7Th99RkRDOMHEbwJLKtWqxGH3vC3O5PJULdpmslkUu8mZ2YmGY3tftzU8ThGIjg6ikNDGAphf7/q7VVdXU5Hh2xrk62toqVFxS/MEyGR+EwTFVxXiP2xbbtGgxCMRiLe3l7ONNE0dwxj24qdZOaZ/z6S9B34F+CfgG8AXwb+FPhj4A+B3yMB/wWYlmDDnRPfSAAAAABJRU5ErkJggg=="
};
import * as wjcCore from '@mescius/wijmo';
import * as wjcGrid from '@mescius/wijmo.grid';
import * as wjcGridPdf from '@mescius/wijmo.grid.pdf';
import * as wjcGridXlsx from '@mescius/wijmo.grid.xlsx';
import * as wjcPdf from '@mescius/wijmo.pdf';
import * as wjcXlsx from '@mescius/wijmo.xlsx';
import { KeyValue, Country, Images } from './data';
const ExcelExportDocName = 'FlexGrid.xlsx';
const PdfExportDocName = 'FlexGrid.pdf';
const FakeColumn = new wjcGrid.Column();
const FakeRow = new wjcGrid.Row();
class Fonts {
}
Fonts.ZapfDingbatsSm = new wjcPdf.PdfFont('zapfdingbats', 8, 'normal', 'normal');
Fonts.ZapfDingbatsLg = new wjcPdf.PdfFont('zapfdingbats', 16, 'normal', 'normal');
export class IExcelExportContext {
}
export class ExportService {
startExcelExport(flex, successCallback, errorCallback, progressCallback) {
wjcGridXlsx.FlexGridXlsxConverter.saveAsync(flex, {
includeColumnHeaders: true,
includeStyles: false,
formatItem: this._formatExcelItem
}, ExcelExportDocName, successCallback, errorCallback, progressCallback, true);
}
cancelExcelExport(doneCollback) {
wjcGridXlsx.FlexGridXlsxConverter.cancelAsync(doneCollback);
}
exportToPdf(flex, options) {
wjcGridPdf.FlexGridPdfConverter.export(flex, PdfExportDocName, {
maxPages: 100,
exportMode: wjcGridPdf.ExportMode.All,
scaleMode: wjcGridPdf.ScaleMode.ActualSize,
documentOptions: {
pageSettings: {
layout: wjcPdf.PdfPageOrientation.Landscape
},
header: {
declarative: {
text: '\t&[Page]\\&[Pages]'
}
},
footer: {
declarative: {
text: '\t&[Page]\\&[Pages]'
}
}
},
styles: {
cellStyle: {
backgroundColor: '#ffffff',
borderColor: '#c6c6c6'
},
altCellStyle: {
backgroundColor: '#f9f9f9'
},
groupCellStyle: {
backgroundColor: '#dddddd'
},
headerCellStyle: {
backgroundColor: '#eaeaea'
},
// Highlight Invalid Cells
errorCellStyle: {
backgroundColor: 'rgba(255, 0, 0, 0.3)'
}
},
customCellContent: false,
formatItem: (e) => this._formatPdfItem(e, options)
});
}
_formatExcelItem(e) {
const panel = e.panel;
if (panel.cellType !== wjcGrid.CellType.Cell) {
return;
}
// highlight invalid cells
if (panel.grid._getError(panel, e.row, e.col)) {
const fill = new wjcXlsx.WorkbookFill();
fill.color = '#ff0000';
e.xlsxCell.style.fill = fill;
}
}
_resetExcelContext(ctx) {
ctx.exporting = false;
ctx.progress = 0;
ctx.preparing = false;
}
_formatPdfItem(e, options) {
const panel = e.panel;
if (panel.cellType !== wjcGrid.CellType.Cell) {
return;
}
switch (panel.columns[e.col].binding) {
case 'countryId':
this._formatPdfCountryCell(e, options.countryMap);
break;
case 'colorId':
this._formatPdfColorCell(e, options.colorMap);
break;
case 'change':
this._formatPdfChangeCell(e);
break;
case 'history':
/*** Version #1: get grid cell produced before by a cell template ***/
// const cell = e.getFormattedCell();
// this._formatPdfHistoryCell(e, cell);
/*** Version #2: create fake cell from a cell template ***/
const history = e.panel.getCellData(e.row, e.col, false);
const cell = this._createCellFromCellTemplate(options.historyCellTemplate, history);
this._formatPdfHistoryCell(e, cell);
break;
case 'rating':
this._formatPdfRatingCell(e);
break;
}
}
_formatPdfCountryCell(e, countryMap) {
e.drawBackground(e.style.backgroundColor);
// check whether country exists
const countryName = e.data;
if (this._isCountryExist(countryName, countryMap)) {
// bound rectangle of cell's content area
const contentRect = e.contentRect;
// draw flag image
const image = e.canvas.openImage(Images[countryName.toLowerCase()]);
const imageTop = contentRect.top + (contentRect.height - image.height) / 2;
e.canvas.drawImage(image, contentRect.left, imageTop);
// draw country name
e.canvas.drawText(countryName, contentRect.left + image.width + 3, e.textTop);
}
// cancel standard cell content drawing
e.cancel = true;
}
_formatPdfColorCell(e, colorMap) {
e.drawBackground(e.style.backgroundColor);
// check whether color exists
const colorName = e.data;
if (this._isColorExist(colorName, colorMap)) {
// bound rectangle of cell's content area
const contentRect = e.contentRect;
// draw color indicator
const imageHeight = Math.min(10, contentRect.height);
const imageWidth = 1.33 * imageHeight;
const imageTop = contentRect.top + (contentRect.height - imageHeight) / 2;
e.canvas.paths
.rect(contentRect.left, imageTop, imageWidth, imageHeight)
.fillAndStroke(wjcCore.Color.fromString(colorName), wjcCore.Color.fromString('gray'));
// draw color name
e.canvas.drawText(colorName, contentRect.left + imageWidth + 3, e.textTop);
}
// cancel standard cell content drawing
e.cancel = true;
}
_formatPdfChangeCell(e) {
e.drawBackground(e.style.backgroundColor);
// get change value and text
const cellData = e.panel.getCellData(e.row, e.col, false);
let change = 0;
let changeText = '';
if (wjcCore.isNumber(cellData)) {
change = cellData;
changeText = wjcCore.Globalize.formatNumber(change, 'c');
}
else if (!wjcCore.isUndefined(cellData) && cellData !== null) {
changeText = wjcCore.changeType(cellData, wjcCore.DataType.String);
}
// determine whether change is positive or negative
let changeIndicator = '';
let changeColor = e.style.color;
if (change > 0) {
changeIndicator = '\x73'; // ▲
changeColor = 'darkgreen';
}
else if (change < 0) {
changeIndicator = '\x74'; // ▼
changeColor = 'darkred';
}
// draw change indicator
let indent = 10;
e.canvas.drawText(changeIndicator, e.contentRect.right - indent, e.contentRect.top + indent, {
brush: changeColor,
font: Fonts.ZapfDingbatsSm
});
// draw change text
indent += 3;
e.canvas.drawText(changeText, e.contentRect.left, e.textTop, {
brush: changeColor,
align: wjcPdf.PdfTextHorizontalAlign.Right,
width: e.contentRect.width - indent
});
// cancel standard cell content drawing
e.cancel = true;
}
_formatPdfHistoryCell(e, cell) {
e.drawBackground(e.style.backgroundColor);
// draw history svg
const svgUrl = this._getHistorySvgDataUrlFromCell(cell, e.clientRect.width, e.clientRect.height);
if (svgUrl) {
let cr = e.contentRect;
e.canvas.drawSvg(svgUrl, cr.left + 2, cr.top + 2, { width: cr.width - 4, height: cr.height - 4 });
}
// cancel standard cell content drawing
e.cancel = true;
}
_getHistorySvgDataUrlFromCell(cell, width, height) {
let dataUrl = null;
// extract SVG from provided cell
const svg = cell.getElementsByTagName('svg')[0];
if (svg) {
const clone = svg.cloneNode(true);
clone.setAttribute('version', '1.1');
clone.setAttributeNS('http://www.w3.org/2000/xmlns/', 'xmlns', 'http://www.w3.org/2000/svg');
clone.style.overflow = 'visible';
clone.style.stroke = '#376092';
clone.style.fill = '#376092';
const s = document.createElement('style');
s.setAttribute('type', 'text/css');
s.innerHTML = `<![CDATA[
line {
stroke-width: 2;
}
circle {
stroke-width: 0;
stroke-opacity: 0;
}
.wj-marker {
fill: #d00000;
opacity: 1;
}
]]>`;
const defs = document.createElement('defs');
defs.appendChild(s);
clone.insertBefore(defs, clone.firstChild);
const outer = document.createElement('div');
outer.appendChild(clone);
dataUrl = 'data:image/svg+xml;base64,' + btoa(unescape(encodeURIComponent(outer.innerHTML)));
}
return dataUrl;
}
_formatPdfRatingCell(e) {
e.drawBackground(e.style.backgroundColor);
// check whether rating is defined
let rating = wjcCore.changeType(e.data, wjcCore.DataType.Number);
if (wjcCore.isInt(rating)) {
const ratingIndicator = '\x48'; // ★
const ratingNormalColor = wjcCore.Color.fromRgba(255, 165, 0, 1); // orange
const ratingLightColor = wjcCore.Color.fromRgba(255, 165, 0, 0.2);
// draw rating indicators
const indent = 16;
const count = 5;
const width = count * indent;
const y = e.clientRect.top + indent;
let x = e.contentRect.left + (e.contentRect.width - width) / 2;
rating = wjcCore.clamp(rating, 1, count);
for (let i = 0; i < count; i++) {
e.canvas.drawText(ratingIndicator, x, y, {
brush: (i < rating) ? ratingNormalColor : ratingLightColor,
font: Fonts.ZapfDingbatsLg,
height: e.clientRect.height
});
x += indent;
}
}
// cancel standard cell content drawing
e.cancel = true;
}
_isCountryExist(countryName, countryMap) {
const countryId = countryMap.getKeyValue(countryName);
if (wjcCore.isUndefined(countryId) || countryId === null) {
return false;
}
if (countryId === Country.NotFound.id) {
return false;
}
return true;
}
_isColorExist(colorName, colorMap) {
const colorId = colorMap.getKeyValue(colorName);
if (wjcCore.isUndefined(colorId) || colorId === null) {
return false;
}
if (colorId === KeyValue.NotFound.key) {
return false;
}
return true;
}
_createCellFromCellTemplate(cellTemplate, data) {
const cell = document.createElement('div');
cellTemplate({
col: FakeColumn,
row: FakeRow,
value: data,
item: null,
text: null
}, cell);
return cell;
}
}
import * as wjcCore from '@mescius/wijmo';
export class RequiredValidator {
validate(name, value) {
const message = name + ' is required';
if (wjcCore.isUndefined(value)) {
return message;
}
const str = wjcCore.changeType(value, wjcCore.DataType.String);
if (wjcCore.isNullOrWhiteSpace(str)) {
return message;
}
return '';
}
}
export class MinValueValidator {
constructor(minValue, message = '{0} can\'t be less than {1}', format = null) {
this.minValue = minValue;
this.message = message;
this.format = format;
}
validate(name, value) {
if (value < this.minValue) {
return wjcCore.format(this.message, {
0: name,
1: this._formatValue(this.minValue)
});
}
return '';
}
}
export class MaxValueValidator {
constructor(maxValue, message = '{0} can\'t be greater than {1}', format = null) {
this.maxValue = maxValue;
this.message = message;
this.format = format;
}
validate(name, value) {
if (value > this.maxValue) {
return wjcCore.format(this.message, {
0: name,
1: this._formatValue(this.maxValue)
});
}
return '';
}
}
export class MinNumberValidator extends MinValueValidator {
constructor(minValue, message = '{0} can\'t be less than {1}', format = 'n') {
super(minValue, message, format);
}
_formatValue(value) {
return wjcCore.Globalize.formatNumber(value, this.format);
}
}
export class MaxNumberValidator extends MaxValueValidator {
constructor(maxValue, message = '{0} can\'t be greater than {1}', format = 'n') {
super(maxValue, message, format);
}
_formatValue(value) {
return wjcCore.Globalize.formatNumber(value, this.format);
}
}
export class MinDateValidator extends MinValueValidator {
constructor(minValue, message = '{0} can\'t be less than {1}', format = 'MM/dd/yyyy') {
super(minValue, message, format);
}
_formatValue(value) {
return wjcCore.Globalize.formatDate(value, this.format);
}
}
export class MaxDateValidator extends MaxValueValidator {
constructor(maxValue, message = '{0} can\'t be greater than {1}', format = 'MM/dd/yyyy') {
super(maxValue, message, format);
}
_formatValue(value) {
return wjcCore.Globalize.formatDate(value, this.format);
}
}
(function (global) {
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true,
},
meta: {
'*.css': { loader: 'css' },
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/latest/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'cdn:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.react.chart.analytics': 'cdn:@mescius/wijmo.react.chart.analytics/index.js',
'@mescius/wijmo.react.chart.animation': 'cdn:@mescius/wijmo.react.chart.animation/index.js',
'@mescius/wijmo.react.chart.annotation': 'cdn:@mescius/wijmo.react.chart.annotation/index.js',
'@mescius/wijmo.react.chart.finance.analytics': 'cdn:@mescius/wijmo.react.chart.finance.analytics/index.js',
'@mescius/wijmo.react.chart.finance': 'cdn:@mescius/wijmo.react.chart.finance/index.js',
'@mescius/wijmo.react.chart.hierarchical': 'cdn:@mescius/wijmo.react.chart.hierarchical/index.js',
'@mescius/wijmo.react.chart.interaction': 'cdn:@mescius/wijmo.react.chart.interaction/index.js',
'@mescius/wijmo.react.chart.radar': 'cdn:@mescius/wijmo.react.chart.radar/index.js',
'@mescius/wijmo.react.chart': 'cdn:@mescius/wijmo.react.chart/index.js',
'@mescius/wijmo.react.core': 'cdn:@mescius/wijmo.react.core/index.js',
'@mescius/wijmo.react.chart.map': 'cdn:@mescius/wijmo.react.chart.map/index.js',
'@mescius/wijmo.react.gauge': 'cdn:@mescius/wijmo.react.gauge/index.js',
'@mescius/wijmo.react.grid.detail': 'cdn:@mescius/wijmo.react.grid.detail/index.js',
'@mescius/wijmo.react.grid.filter': 'cdn:@mescius/wijmo.react.grid.filter/index.js',
'@mescius/wijmo.react.grid.grouppanel': 'cdn:@mescius/wijmo.react.grid.grouppanel/index.js',
'@mescius/wijmo.react.grid.search': 'cdn:@mescius/wijmo.react.grid.search/index.js',
'@mescius/wijmo.react.grid.multirow': 'cdn:@mescius/wijmo.react.grid.multirow/index.js',
'@mescius/wijmo.react.grid.sheet': 'cdn:@mescius/wijmo.react.grid.sheet/index.js',
'@mescius/wijmo.react.grid.transposed': 'cdn:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'cdn:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'cdn:@mescius/wijmo.react.grid.immutable/index.js',
'@mescius/wijmo.react.grid': 'cdn:@mescius/wijmo.react.grid/index.js',
'@mescius/wijmo.react.input': 'cdn:@mescius/wijmo.react.input/index.js',
'@mescius/wijmo.react.olap': 'cdn:@mescius/wijmo.react.olap/index.js',
'@mescius/wijmo.react.viewer': 'cdn:@mescius/wijmo.react.viewer/index.js',
'@mescius/wijmo.react.nav': 'cdn:@mescius/wijmo.react.nav/index.js',
'@mescius/wijmo.react.base': 'cdn:@mescius/wijmo.react.base/index.js',
'@mescius/wijmo.react.barcode.common': 'cdn:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'cdn:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'cdn:@mescius/wijmo.react.barcode.specialized/index.js',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
react: 'pcdn:react@19.0.0/index.js',
'react-dom': 'pcdn:react-dom@19.0.0/index.js',
'react-dom/client': 'pcdn:react-dom@19.0.0/client.js',
scheduler: 'pcdn:scheduler@0.25.0/index.js',
redux: 'pcdn:redux@5.0.1/dist/redux.legacy-esm.js',
'react-redux': 'pcdn:react-redux@9.2.0/dist/react-redux.legacy-esm.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
'react-use-event-hook': 'pcdn:react-use-event-hook@0.9.6/dist/esm/useEvent.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx',
},
node_modules: {
defaultExtension: 'js',
},
},
});
})(this);

<template>
<main class="container-fluid">
<div class="row">
<!-- search box -->
<div class="toolbar-item col-sm-3 col-md-5">
<wj-flex-grid-search placeholder="Search" cssMatch="" :initialized="searchInitialized" />
</div>
<!-- data size -->
<div class="toolbar-item col-sm-3 col-md-3">
<div class="input-group">
<span class="input-group-addon">Items:</span>
<select class="form-control" v-model="itemsCount" aria-label="Data Size">
<option value="5">5</option>
<option value="50">50</option>
<option value="500">500</option>
<option value="5000">5,000</option>
<option value="50000">50,000</option>
<option value="100000">100,000</option>
</select>
</div>
</div>
<!-- export to Excel -->
<div class="toolbar-item col-sm-3 col-md-2">
<excel-export-button :exportService="exportService" :getFlex="getFlex" />
</div>
<!-- export to PDF -->
<div class="toolbar-item col-sm-3 col-md-2">
<button class="btn btn-default btn-block" @click="exportToPdf">Export To PDF</button>
</div>
</div>
<!-- group panel -->
<wj-group-panel :placeholder="'Drag columns here to create groups'" :initialized="groupPanelInitialized" />
<!-- the grid -->
<wj-flex-grid :autoGenerateColumns="false" :allowAddNew="true" :allowDelete="true"
:allowPinning="'SingleColumn'" :newRowAtTop="true" :showMarquee="true" :selectionMode="'MultiRange'"
:validateEdits="false" :initialized="gridInitialized">
<wj-flex-grid-filter
:filterColumns="['id', 'date', 'time', 'countryId', 'productId', 'colorId', 'price', 'change', 'discount', 'rating', 'active']" />
<wj-flex-grid-column binding="id" header="ID" :width="70" :isReadOnly="true" />
<wj-flex-grid-column binding="date" header="Date" format="MMM d yyyy" :isRequired="false" :width="130"
:editor="editors.inputDate">
</wj-flex-grid-column>
<wj-flex-grid-column binding="countryId" header="Country" :dataMap="countryMap" :width="145">
<wj-flex-grid-cell-template cellType="Cell" v-slot="cell">
<span :class="'flag-icon flag-icon-' + getCountry(cell.item).flag"></span>
{{ getCountry(cell.item).name }}
</wj-flex-grid-cell-template>
</wj-flex-grid-column>
<wj-flex-grid-column binding="price" header="Price" format="c" :isRequired="false" :width="100" />
<wj-flex-grid-column binding="history" header="History" :width="180" align="center" :allowSorting="false"
:cellTemplate="historyCellTemplate">
</wj-flex-grid-column>
<wj-flex-grid-column binding="change" header="Change" align="right" :width="115">
<wj-flex-grid-cell-template cellType="Cell" v-slot="cell">
<span :class="getChangeCls(cell.item.change)">
{{ safeCurrency(cell.item.change) }}
</span>
</wj-flex-grid-cell-template>
</wj-flex-grid-column>
<wj-flex-grid-column binding="rating" header="Rating" :width="180" align="center" cssClass="cell-rating"
:cellTemplate="ratingCellTemplate">
</wj-flex-grid-column>
<wj-flex-grid-column binding="time" header="Time" format="HH:mm" :isRequired="false" :width="95"
:editor="editors.inputTime">
</wj-flex-grid-column>
<wj-flex-grid-column binding="colorId" header="Color" :dataMap="colorMap" :width="145">
<wj-flex-grid-cell-template cellType="Cell" v-slot="cell">
<span class="color-tile" :style="{ background: getColor(cell.item).value }"></span>
{{ getColor(cell.item).value }}
</wj-flex-grid-cell-template>
</wj-flex-grid-column>
<wj-flex-grid-column binding="productId" header="Product" :dataMap="productMap" :width="145" />
<wj-flex-grid-column binding="discount" header="Discount" format="p0" :width="130" />
<wj-flex-grid-column binding="active" header="Active" :width="100" />
</wj-flex-grid>
</main>
</template>
<script setup>
import "@mescius/wijmo.touch";
import * as wjCore from "@mescius/wijmo";
import { InputDate, InputTime } from "@mescius/wijmo.input";
import { DataMap } from "@mescius/wijmo.grid";
import { CellMaker, SparklineMarkers } from "@mescius/wijmo.grid.cellmaker";
import { Country, DataService, KeyValue } from "./data";
import { ExportService } from "./export";
import ExcelExportButton from "./export-btn.vue";
import { ref, computed, watch } from "vue";
const itemsCount = ref(500);
const editors = ref({
inputDate: new InputDate(document.createElement("div"), {
format: "MM/dd/yyyy",
isRequired: false,
}),
inputTime: new InputTime(document.createElement("div"), {
format: "HH:mm",
isRequired: false,
}),
});
const dataService = ref(new DataService());
const exportService = ref(new ExportService());
const _lastId = ref(itemsCount.value);
const productMap = ref(_buildDataMap(dataService.value.getProducts()));
const countryMap = ref(new DataMap(dataService.value.getCountries(), 'id', 'name'));
const colorMap = ref(_buildDataMap(dataService.value.getColors()));
const historyCellTemplate = ref(null);
const ratingCellTemplate = ref(null);
const flex = ref(null);
const groupPanel = ref(null);
const search = ref(null);
// initializes cell templates
historyCellTemplate.value = CellMaker.makeSparkline({
markers: SparklineMarkers.High | SparklineMarkers.Low,
maxPoints: 25,
label: 'price history',
});
ratingCellTemplate.value = CellMaker.makeRating({
range: [1, 5],
label: 'rating'
});
computed({
productMap: function () {
return productMap;
},
countryMap: function () {
return countryMap;
},
colorMap: function () {
return colorMap;
},
});
watch(itemsCount, (newItemsCount) => {
flex.value.itemsSource.collectionChanged.removeAllHandlers();
_lastId.value = newItemsCount
flex.value.itemsSource = _createItemsSource(newItemsCount);
});
function gridInitialized(ctl) {
flex.value = ctl;
flex.value.itemsSource = _createItemsSource(itemsCount.value);
if (groupPanel.value) {
groupPanel.value.grid = flex.value;
}
if (search.value) {
search.value.grid = flex.value;
}
}
function searchInitialized(ctl) {
search.value = ctl;
if (flex.value) {
search.value.grid = flex.value;
}
}
function groupPanelInitialized(ctl) {
groupPanel.value = ctl;
if (flex.value) {
groupPanel.value.grid = flex.value;
}
}
function exportToPdf() {
exportService.value.exportToPdf(flex.value, {
countryMap: countryMap.value,
colorMap: colorMap.value,
historyCellTemplate: historyCellTemplate.value,
});
}
function getCountry(item) {
const country = countryMap.value.getDataItem(item.countryId);
return country ? country : Country.NotFound;
}
function getColor(item) {
const color = colorMap.value.getDataItem(item.colorId);
return color ? color : KeyValue.NotFound;
}
function getChangeCls(value) {
if (wjCore.isNumber(value)) {
if (value > 0) {
return "change-up";
}
if (value < 0) {
return "change-down";
}
}
return "";
}
function _createItemsSource(counter) {
const data = dataService.value.getData(counter);
const view = new wjCore.CollectionView(data, {
getError: function (item, prop) {
const displayName = flex.value.columns.getColumn(prop).header;
return dataService.value.validate(item, prop, displayName);
}.bind(this),
});
view.collectionChanged.addHandler(
function (s, e) {
// initializes new added item with a history data
if (e.action === wjCore.NotifyCollectionChangedAction.Add) {
e.item.history = dataService.value.getHistoryData();
e.item.id = _lastId.value;
_lastId.value++;
}
}.bind(this),
);
return view;
}
function _buildDataMap(items) {
const map = [];
for (let i = 0; i < items.length; i++) {
map.push({ key: i, value: items[i] });
}
return new DataMap(map, "key", "value");
}
function getFlex() {
return flex.value;
}
function safeCurrency(value) {
if (wjCore.isNumber(value)) {
return wjCore.Globalize.formatNumber(value, "c");
}
if (!wjCore.isUndefined(value) && value !== null) {
return wjCore.changeType(value, wjCore.DataType.String);
}
return "";
}
</script>
<style>
@import "./node_modules/bootstrap/dist/css/bootstrap.css";
@import "./node_modules/@mescius/wijmo.styles/wijmo.css";
@import url('https://cdnjs.cloudflare.com/ajax/libs/flag-icon-css/3.1.0/css/flag-icon.css');
body {
font-size: 1.5em;
font-family: -apple-system, BlinkMacSystemFont, "Segoe UI Light", Roboto, Oxygen-Sans, Ubuntu, Cantarell, "Helvetica Neue", sans-serif;
}
.toolbar-item {
margin-bottom: 6px;
}
.wj-flexgridsearch {
width: 100%;
}
.wj-flexgrid {
height: 330px;
}
.wj-flexgrid .wj-cell {
padding: 7px;
border: none;
}
.wj-cell.wj-state-invalid:not(.wj-header)::after {
top: -14px;
border: 14px solid transparent;
border-right-color: red;
}
.flag-icon {
box-shadow: 1px 1px 4px rgba(0, 0, 0, 0.4);
}
.color-tile {
display: inline-block;
position: relative;
width: 1em;
height: 1em;
border-radius: 50%;
box-shadow: 1px 1px 4px rgba(0, 0, 0, 0.4);
vertical-align: middle;
}
.change-up {
color: darkgreen;
}
.change-up:after {
content: '\25b2';
}
.change-down {
color: darkred;
}
.change-down:after {
content: '\25bc';
}
.cell-rating {
font-size: 12px;
}
.wj-flexgrid .wj-detail {
padding: 4px 16px;
}
.wj-detail h3 {
margin: 10px 0;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexGrid Overview</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app">
</div>
</body>
</html>
import * as wjcCore from '@mescius/wijmo';
import {
RequiredValidator, MinNumberValidator, MinDateValidator,
MaxNumberValidator, MaxDateValidator
} from './validation';
//
export class KeyValue {
key;
value;
static NotFound = { key: -1, value: '' };
}
//
export class Country {
name;
id;
flag;
static NotFound = { id: -1, name: '', flag: '' };
}
//
export class DataService {
_products = ['Widget', 'Gadget', 'Doohickey'];
_colors = ['Black', 'White', 'Red', 'Green', 'Blue'];
_countries = [
{ id: 0, name: 'US', flag: 'us' },
{ id: 1, name: 'Germany', flag: 'de' },
{ id: 2, name: 'UK', flag: 'gb' },
{ id: 3, name: 'Japan', flag: 'jp' },
{ id: 4, name: 'Italy', flag: 'it' },
{ id: 5, name: 'Greece', flag: 'gr'}
];
_validationConfig = {
'date': [
new RequiredValidator(),
new MinDateValidator(new Date('2000-01-01T00:00:00')),
new MaxDateValidator(new Date('2100-01-01T00:00:00'))
],
'time': [
new RequiredValidator(),
new MinDateValidator(new Date('2000-01-01T00:00:00')),
new MaxDateValidator(new Date('2100-01-01T00:00:00'))
],
'productId': [
new RequiredValidator(),
new MinNumberValidator(0, `{0} can't be less than {1} (${this._products[0]})`),
new MaxNumberValidator(
this._products.length - 1,
`{0} can't be greater than {1} (${this._products[this._products.length - 1]})`
)
],
'countryId': [
new RequiredValidator(),
new MinNumberValidator(0, `{0} can't be less than {1} (${this._countries[0].name})`),
new MaxNumberValidator(
this._countries.length - 1,
`{0} can't be greater than {1} (${this._countries[this._countries.length - 1].name})`
)
],
'colorId': [
new RequiredValidator(),
new MinNumberValidator(0, `{0} can't be less than {1} (${this._colors[0]})`),
new MaxNumberValidator(
this._colors.length - 1,
`{0} can't be greater than {1} (${this._colors[this._colors.length - 1]})`
)
],
'price': [
new RequiredValidator(),
new MinNumberValidator(0, `Price can't be a negative value`)
]
};
getCountries() {
return this._countries;
}
getProducts() {
return this._products;
}
getColors() {
return this._colors;
}
getHistoryData() {
return this._getRandomArray(25, 100);
}
getData(count) {
const data = [];
const dt = new Date();
const year = dt.getFullYear();
const itemsCount = Math.max(count, 5);
// add items
for (let i = 0; i < itemsCount; i++) {
const item = this._getItem(i, year);
data.push(item);
}
// set invalid data to demonstrate errors visualization
data[1].price = -2000;
data[2].date = new Date('1970-01-01T00:00:00');
data[4].time = undefined;
data[4].price = -1000;
return data;
}
validate(item, prop, displayName) {
const validators = this._validationConfig[prop];
if (wjcCore.isUndefined(validators)) {
return '';
}
const value = item[prop];
for (let i = 0; i < validators.length; i++) {
const validationError = validators[i].validate(displayName, value);
if (!wjcCore.isNullOrWhiteSpace(validationError)) {
return validationError;
}
}
}
_getItem(i, year) {
const date = new Date(year, i % 12, 25, i % 24, i % 60, i % 60);
const countryIndex = this._getRandomIndex(this._countries)
const productIndex = this._getRandomIndex(this._products);
const colorIndex = this._getRandomIndex(this._colors);
const item = {
id: i,
date: date,
time: new Date(date.getTime() + Math.random() * 30 * (24 * 60 * 60 * 1000)),
countryId: this._countries[countryIndex].id,
productId: productIndex,
colorId: colorIndex,
price: wjcCore.toFixed(Math.random() * 10000 + 5000, 2, true),
change: wjcCore.toFixed(Math.random() * 1000 - 500, 2, true),
history: this.getHistoryData(),
discount: wjcCore.toFixed(Math.random() / 4, 2, true),
rating: this._getRating(),
active: i % 4 == 0,
size: Math.floor(100 + Math.random() * 900),
weight: Math.floor(100 + Math.random() * 900),
quantity: Math.floor(Math.random() * 10),
description: "Across all our software products and services, our focus is on helping our customers achieve their goals. Our key principles – thoroughly understanding our customers' business objectives, maintaining a strong emphasis on quality, and adhering to the highest ethical standards – serve as the foundation for everything we do."
};
return item;
}
_getRating() {
return Math.ceil(Math.random() * 5);
}
_getRandomIndex(arr) {
return Math.floor(Math.random() * arr.length);
}
_getRandomArray(len, maxValue) {
const arr = [];
for (let i = 0; i < len; i++) {
arr.push(Math.floor(Math.random() * maxValue));
}
return arr;
}
}
export const Images = {
"germany": "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAALCAIAAAD5gJpuAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAadEVYdFNvZnR3YXJlAFBhaW50Lk5FVCB2My41LjExR/NCNwAAAhBJREFUKFNj8PFx9vG08nG38PGycXOzcnA0s7c3tLfXx4UY3N2tdu3aCEQ7dqzftm3t5s0rN2xYvnbt4lWr5i9bNnvRounz5k6aNatv2rTOiRNbQBo8PW2Aqpuam+vq6qqqqkpLS/Pz8zMzMpOSkqKjo0NCQnx9fV1dXe1sbXt760Ea0jxtTu1YP7+ubnZV1fSSksn5+X0ZGZ2Jic3R0XXBwRU+3oWuLjk2Nqlmpks7q0Aa9rmY/t265m9l5Z/i4t95eb8yMn4mJv6IivoWFPzF2/uzi8tHG5sPxqbvdHU/t5StBGrYa6//Z9NKkOrcvF9paT8TEr5HRn4LCvri5fXZ2Rmo+r2x8TsdnTcqqp/qC1YANewBali/9HduLkh1fDxIdWDgF0/PT05OH62t3xsZvdPRfq2i8kpO7mNN9lKghu2V+n+uLvm1Kfvn+pTvq2K/Lg37ssj/01z3jzMd30+xfDfB6HW31qt2lRdNsh+25cwFati2XP/3x0U/n2V8f5L49VHUlwfBn+56f7zt+v6m7dvr5q+v6L+8qPnivNKzs7LvH+TObgFqWKj/6+3cn69n/Xw95cfLid+fd3992v71SdOXR/WfH1R9ulf28W7xhzv5729nv7+VObdSn2Fdn/62bv0trfqbO/TX1Ouvqtdf2au/ulV/ZZP+4lb9BfX682r0F9fpLyzTX1ipP7lYHwAoyRFNzrKSzQAAAABJRU5ErkJggg==",
"greece": "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAALCAIAAAD5gJpuAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAadEVYdFNvZnR3YXJlAFBhaW50Lk5FVCB2My41LjExR/NCNwAAAgJJREFUKFNF0d1LU3EYB/AnuhgG0WXddBFdRYREDQkT/4GkuxKJXojo2oIuoosMwUJhtJBJJmsOM1diJGtNm869tNNx0xWbNXE6z17OOds523n/nXP21nEL+vK9/HzhgQeO9oaNJlvp6Al2dIfAvAadq3DGB6e9cNIDxxfh2AKY5uHQB4DZg8HVh8lms9loNPoeJPsGE5peU7UaMqpWEdIVpMmKKslIkNCvrTQQBNHW7dTr9UCU8a8zK3jpG1ZcjtDeMO0JUe4AuYLTQ8Oxg8E/29JGrLNZy8z+6HTmuX13+E366cTOk/Htx9bU2HQaTjjA1B00Lmnr3vs/e+7FRVkXJU0QVV5EnKBUOJmtSExZKHMShm/BYXPwymDC0LVazdCX725eurPRdTtmvhm7cCN6fmC9sx8/d/3H2WtY162o6dQcUBRj0Gq1qutVTdNVVUNIUxRVlpEkyaIo8YLIcQLH8YIgxuMJsLkym78r4Tgb2mACsZI/WlzFiz6MXo5QS2Hya6jwJVhwr+UX/TkfRg49w6D/Eeb9zs4tke88Bac7//ZzdmqBeD2/b3Ptjb/ftc7sWJzbY47UC/ufyY/pIxcdkNrjy7zKcogtoxKr0KxMMRJVFAu0kKf4HMllCxyRrxA5NpNlXZ8i8P+R0HokOAHsAJMANoBXAC8BLACjrY4AjPwFh3JwhG+uVAQAAAAASUVORK5CYII=",
"italy": "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAALCAIAAAD5gJpuAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAadEVYdFNvZnR3YXJlAFBhaW50Lk5FVCB2My41LjExR/NCNwAAAX5JREFUKFNdzL1LAnEcx/HPLpSgSy225KIgCinUcA06iKDCXXSSIhUUtAhFijk0SEhj/0ZQJGVhz2GkBv4FIiKHRESE9+D5kNLvd07dl8/4en+BE+BYWw7Iot1uC4LQarWazWaj0ajX6wogAR3gB/gGuSNk3jNk6Uo6VU6Nx+PRiGz0q91wOBxEo/3V1R7LqsHgFw2OSXAQf4pHH6KR2wihE03pYNDv93sej+p0du121e//pEEO5DfR/F2Eu+H0utej2mZTrNau1/sxCZKVJH/Pc0UuXAjrtapSPT8vz80pDKMFWey+7bFFNnQdClwG9LrbpdpikWZn5aWlNg0OkXhNhG5C/iu/78Kn14pC9cyMaDbLbrdAgwx2SjtU533LZ4xey/JEi0aj5HI1aZDC1vOWN+9lzpnF00W9liTRZOpMT3UMBtHh0IIE1h83YvcxvshzhZVJ8K9ZWBBdLqJFu71Bg31gG9gE1gAWtVqtWq2Wy+VSqfSiXQsgjwmlA/4AQZc4Q1AkNCsAAAAASUVORK5CYII=",
"japan": "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAALCAIAAAD5gJpuAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAadEVYdFNvZnR3YXJlAFBhaW50Lk5FVCB2My41LjExR/NCNwAAAVFJREFUKFNVkb2KwkAUhfMwVrHQwh/YWOgWKlin8kks3H0IF6xtbXyAPERQCaISgogEFRE1mcxPsrtnZrIuHobLFN+ZufdcI37VQ+l2u12VLpfL+Xw+Ho9hGB4Oh91+Lw0/St9/yjKcLFUSQnDOGWOU0iRJgiDIDTkr6SxznPTjUwwGfDZ7ooQQVN/3pSFnNT2dpr2e6HR46501GvRrpGlgqNvt9t8g6dMptW3RbvNWi1kNWqsl9TrZbMBEUYS6Wq0MjKhp2fJiIelmk1mWpMtlUizGjgMaGBye5xkIRNMCE4Yh73aZ9Uar1aRUIqYZm2bkeaDv9ztsy+VSGnQaeSDjMa1UcrpQiIZDTUO4SAPChgFoHh9mnExIvx/bdjQaPa5XoHgUwsV1XQOreYb9DDFBJmpK3T1eV38ow+sid1gNwkZ86/UamWBKtDGfz4FKue4vduTCcIOSUSoAAAAASUVORK5CYII=",
"uk": "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAALCAIAAAD5gJpuAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAadEVYdFNvZnR3YXJlAFBhaW50Lk5FVCB2My41LjExR/NCNwAAAepJREFUKFNjmDRz346rb6qnH0tpBqLDiY0Hbt59uza5cU1CHZDhmb3NI22HbcyGqMadcwLzq+ceZViy4tT/jav+/ft/++GXRRtuz19/B8j+P6Xnf18rkDFp4eXeuRdOnnj8r6vm39+fEzZdYEhqObjn5Lv/S5f/P7j3////bdOuAsn/qZn/ExKBdEnfpS+L1nzv7gay5626JGkyA6Rh4Ya7dROvPtx3/09TPUg1EMTE/A+PADFyM/+/eHHhzltHz+VFTUcEdScyAB0KcgMaCA397+cHZcMAUNmZay8Z1iTW/p/c8T8l5X98/P/IyP8hISClPj7/XF1/2dv/tLT8bmLyVU/vq7b2z2C3VnkrHDbY2v4xswCzQHJ///798/fP7z9/Tl59wWAft6lnzvmotB1Xrr7///bNz+R4kCojk9/6hmANf586Oe6fuVVCelZIwnoG4WwG87B1i9eDQuZzY92Hrq6YkmNA9h9t3V+a2kBXW9kv+fn//5dZc18kxDRNPccgmM4wefPlf//+fm+vOHrgdmHDwbyGw0AX/g3x+B3k/O/v3/C0baFxq7cfvvX3z4/XCb7ZRUsYquYdmOKS7Jy5SFBnDo/GZA7VCeevvWiVtmgRNzl95SWDeDGDaAGDcK6IYV3vnuuupnkAPExoqtcH3joAAAAASUVORK5CYII=",
"us": "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAALCAIAAAD5gJpuAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAadEVYdFNvZnR3YXJlAFBhaW50Lk5FVCB2My41LjExR/NCNwAAAeBJREFUKFNVkU1IVFEcxS/ozo0rN24EN2JiOYtyBoYGghEvQoItBCGof9FERB8zfSKOuHAZuEoqUltEkBCRplJpRi2MdhXFMIm+4TGfzud7M/e++7+v/q+k6HKW55zfvecyOPf+n86+A1gHWAVYAXiupy7izdMZ4AbwHeDbwBPAvYDr6kdvUf10FtZRKfXgDUopZtfQcSQdIRqNRp1Ur1uLi3NegNyDU0540jk24QRvy8AteeSGPBgVGI3iKcCREzgwgMGgvjv99Tdhg4qp6eiEY9s2uUulErmbY6JarZbL5WKxWCgUtB6zrOrW1iaje1MgNL7ffTjmdTdHK+z8axwexnAYAwHl86meHn1n/INHgFW6N7krlQq58/l80xUzlUqx48t/unO5XDabTafT31y9tPSEAiv3X6H/uvRdE4cui6ZLuyyyxgZfsgMv0O9XfX2qu1t1djrt7Th99RkRDOMHEbwJLKtWqxGH3vC3O5PJULdpmslkUu8mZ2YmGY3tftzU8ThGIjg6ikNDGAphf7/q7VVdXU5Hh2xrk62toqVFxS/MEyGR+EwTFVxXiP2xbbtGgxCMRiLe3l7ONNE0dwxj24qdZOaZ/z6S9B34F+CfgG8AXwb+FPhj4A+B3yMB/wWYlmDDnRPfSAAAAABJRU5ErkJggg=="
};
import * as wjcCore from '@mescius/wijmo';
import * as wjcGrid from '@mescius/wijmo.grid';
import * as wjcGridPdf from '@mescius/wijmo.grid.pdf';
import * as wjcGridXlsx from '@mescius/wijmo.grid.xlsx';
import * as wjcPdf from '@mescius/wijmo.pdf';
import * as wjcXlsx from '@mescius/wijmo.xlsx';
import { KeyValue, Country, Images } from './data';
//
const ExcelExportDocName = 'FlexGrid.xlsx';
const PdfExportDocName = 'FlexGrid.pdf';
const FakeColumn = new wjcGrid.Column();
const FakeRow = new wjcGrid.Row();
//
class Fonts {
static ZapfDingbatsSm = new wjcPdf.PdfFont('zapfdingbats', 8, 'normal', 'normal');
static ZapfDingbatsLg = new wjcPdf.PdfFont('zapfdingbats', 16, 'normal', 'normal');
}
//
export class ExportService {
startExcelExport(flex, successCallback, errorCallback, progressCallback) {
wjcGridXlsx.FlexGridXlsxConverter.saveAsync(flex, {
includeColumnHeaders: true,
includeStyles: false,
formatItem: this._formatExcelItem.bind(this)
},
ExcelExportDocName,
successCallback,
errorCallback,
progressCallback,
true
);
}
cancelExcelExportAsync(doneCollback) {
wjcGridXlsx.FlexGridXlsxConverter.cancelAsync(doneCollback);
}
cancelExcelExport(ctx) {
wjcGridXlsx.FlexGridXlsxConverter.cancelAsync(() => {
console.log('Export to Excel canceled');
this._resetExcelContext(ctx);
});
}
exportToPdf(flex, options) {
wjcGridPdf.FlexGridPdfConverter.export(flex, PdfExportDocName, {
maxPages: 100,
exportMode: wjcGridPdf.ExportMode.All,
scaleMode: wjcGridPdf.ScaleMode.ActualSize,
documentOptions: {
pageSettings: {
layout: wjcPdf.PdfPageOrientation.Landscape
},
header: {
declarative: {
text: '\t&[Page]\\&[Pages]'
}
},
footer: {
declarative: {
text: '\t&[Page]\\&[Pages]'
}
}
},
styles: {
cellStyle: {
backgroundColor: '#ffffff',
borderColor: '#c6c6c6'
},
altCellStyle: {
backgroundColor: '#f9f9f9'
},
groupCellStyle: {
backgroundColor: '#dddddd'
},
headerCellStyle: {
backgroundColor: '#eaeaea'
},
// Highlight Invalid Cells
errorCellStyle: {
backgroundColor: 'rgba(255, 0, 0, 0.3)'
}
},
customCellContent: false,
formatItem: (e) => this._formatPdfItem(e, options)
});
}
_formatExcelItem(e) {
const panel = e.panel;
if (panel.cellType !== wjcGrid.CellType.Cell) {
return;
}
// highlight invalid cells
if (panel.grid._getError(panel, e.row, e.col)) {
const fill = new wjcXlsx.WorkbookFill();
fill.color = '#ff0000';
e.xlsxCell.style.fill = fill;
}
}
_resetExcelContext(ctx) {
ctx.exporting = false;
ctx.progress = 0;
ctx.preparing = false;
}
_formatPdfItem(e, options) {
const panel = e.panel;
if (panel.cellType !== wjcGrid.CellType.Cell) {
return;
}
switch (panel.columns[e.col].binding) {
case 'countryId':
this._formatPdfCountryCell(e, options.countryMap);
break;
case 'colorId':
this._formatPdfColorCell(e, options.colorMap);
break;
case 'change':
this._formatPdfChangeCell(e);
break;
case 'history':
/*** Version #1: get grid cell produced before by a cell template ***/
// const cell = e.getFormattedCell();
// this._formatPdfHistoryCell(e, cell);
/*** Version #2: create fake cell from a cell template ***/
const history = e.panel.getCellData(e.row, e.col, false);
const cell = this._createCellFromCellTemplate(options.historyCellTemplate, history);
this._formatPdfHistoryCell(e, cell);
break;
case 'rating':
this._formatPdfRatingCell(e);
break;
}
}
_formatPdfCountryCell(e, countryMap) {
e.drawBackground(e.style.backgroundColor);
// check whether country exists
const countryName = e.data;
if (this._isCountryExist(countryName, countryMap)) {
// bound rectangle of cell's content area
const contentRect = e.contentRect;
// draw flag image
const image = e.canvas.openImage(Images[countryName.toLowerCase()]);
const imageTop = contentRect.top + (contentRect.height - image.height) / 2;
e.canvas.drawImage(image, contentRect.left, imageTop);
// draw country name
e.canvas.drawText(countryName, contentRect.left + image.width + 3, e.textTop);
}
// cancel standard cell content drawing
e.cancel = true;
}
_formatPdfColorCell(e, colorMap) {
e.drawBackground(e.style.backgroundColor);
// check whether color exists
const colorName = e.data;
if (this._isColorExist(colorName, colorMap)) {
// bound rectangle of cell's content area
const contentRect = e.contentRect;
// draw color indicator
const imageHeight = Math.min(10, contentRect.height);
const imageWidth = 1.33*imageHeight;
const imageTop = contentRect.top + (contentRect.height - imageHeight) / 2;
e.canvas.paths
.rect(contentRect.left, imageTop, imageWidth, imageHeight)
.fillAndStroke(wjcCore.Color.fromString(colorName), wjcCore.Color.fromString('gray'));
// draw color name
e.canvas.drawText(colorName, contentRect.left + imageWidth + 3, e.textTop);
}
// cancel standard cell content drawing
e.cancel = true;
}
_formatPdfChangeCell(e) {
e.drawBackground(e.style.backgroundColor);
// get change value and text
const cellData = e.panel.getCellData(e.row, e.col, false);
let change = 0;
let changeText = '';
if (wjcCore.isNumber(cellData)) {
change = cellData;
changeText = wjcCore.Globalize.formatNumber(change, 'c');
} else if (!wjcCore.isUndefined(cellData) && cellData !== null) {
changeText = wjcCore.changeType(cellData, wjcCore.DataType.String);
}
// determine whether change is positive or negative
let changeIndicator = '';
let changeColor = e.style.color;
if (change > 0) {
changeIndicator = '\x73' // ▲
changeColor = 'darkgreen';
} else if (change < 0) {
changeIndicator = '\x74' // ▼
changeColor = 'darkred';
}
// draw change indicator
let indent = 10;
e.canvas.drawText(changeIndicator, e.contentRect.right - indent, e.contentRect.top + indent, {
brush: changeColor,
font: Fonts.ZapfDingbatsSm
});
// draw change text
indent += 3;
e.canvas.drawText(changeText, e.contentRect.left, e.textTop, {
brush: changeColor,
align: wjcPdf.PdfTextHorizontalAlign.Right,
width: e.contentRect.width - indent
});
// cancel standard cell content drawing
e.cancel = true;
}
_formatPdfHistoryCell(e, cell) {
e.drawBackground(e.style.backgroundColor);
// draw history svg
const svgUrl = this._getHistorySvgDataUrlFromCell(cell, e.clientRect.width, e.clientRect.height);
if (svgUrl) {
let cr = e.contentRect;
e.canvas.drawSvg(svgUrl, cr.left + 2, cr.top + 2, { width: cr.width - 4, height: cr.height - 4 });
}
// cancel standard cell content drawing
e.cancel = true;
}
_getHistorySvgDataUrlFromCell(cell, width, height) {
let dataUrl = null;
// extract SVG from provided cell
const svg = cell.getElementsByTagName('svg')[0];
if (svg) {
const clone = svg.cloneNode(true);
clone.setAttribute('version', '1.1');
clone.setAttributeNS('http://www.w3.org/2000/xmlns/', 'xmlns', 'http://www.w3.org/2000/svg');
clone.style.overflow = 'visible';
clone.style.stroke = '#376092';
clone.style.fill = '#376092';
const s = document.createElement('style');
s.setAttribute('type', 'text/css');
s.innerHTML = `<![CDATA[
line {
stroke-width: 2;
}
circle {
stroke-width: 0;
stroke-opacity: 0;
}
.wj-marker {
fill: #d00000;
opacity: 1;
}
]]>`;
const defs = document.createElement('defs');
defs.appendChild(s);
clone.insertBefore(defs, clone.firstChild);
const outer = document.createElement('div');
outer.appendChild(clone);
dataUrl = 'data:image/svg+xml;base64,' + btoa(unescape(encodeURIComponent(outer.innerHTML)));
}
return dataUrl;
}
_formatPdfRatingCell(e) {
e.drawBackground(e.style.backgroundColor);
// check whether rating is defined
let rating = wjcCore.changeType(e.data, wjcCore.DataType.Number);
if (wjcCore.isInt(rating)) {
const ratingIndicator = '\x48' // ★
const ratingNormalColor = wjcCore.Color.fromRgba(255, 165, 0, 1); // orange
const ratingLightColor = wjcCore.Color.fromRgba(255, 165, 0, 0.2);
// draw rating indicators
const indent = 16;
const count = 5;
const width = count * indent;
const y = e.clientRect.top + indent;
let x = e.contentRect.left + (e.contentRect.width - width) / 2;
rating = wjcCore.clamp(rating, 1, count);
for (let i = 0; i < count; i++) {
e.canvas.drawText(ratingIndicator, x, y, {
brush: (i < rating) ? ratingNormalColor : ratingLightColor,
font: Fonts.ZapfDingbatsLg,
height: e.clientRect.height
});
x += indent;
}
}
// cancel standard cell content drawing
e.cancel = true;
}
_isCountryExist(countryName, countryMap) {
const countryId = countryMap.getKeyValue(countryName);
if (wjcCore.isUndefined(countryId) || countryId === null) {
return false;
}
if (countryId === Country.NotFound.id) {
return false;
}
return true;
}
_isColorExist(colorName, colorMap) {
const colorId = colorMap.getKeyValue(colorName);
if (wjcCore.isUndefined(colorId) || colorId === null) {
return false;
}
if (colorId === KeyValue.NotFound.key) {
return false;
}
return true;
}
_createCellFromCellTemplate(cellTemplate, data) {
const cell = document.createElement('div');
cellTemplate({
col: FakeColumn,
row: FakeRow,
value: data,
item: null,
text: null
}, cell);
return cell;
}
}
import * as wjcCore from '@mescius/wijmo';
export class RequiredValidator {
validate(name, value) {
const message = name + ' is required';
if (wjcCore.isUndefined(value)) {
return message;
}
const str = wjcCore.changeType(value, wjcCore.DataType.String);
if (wjcCore.isNullOrWhiteSpace(str)) {
return message;
}
return '';
}
}
export class MinValueValidator {
constructor(minValue, message = '{0} can\'t be less than {1}', format = null) {
this.minValue = minValue;
this.message = message;
this.format = format;
}
validate(name, value) {
if (value < this.minValue) {
return wjcCore.format(this.message, {
0: name,
1: this._formatValue(this.minValue)
});
}
return '';
}
}
export class MaxValueValidator {
constructor(maxValue, message = '{0} can\'t be greater than {1}', format = null) {
this.maxValue = maxValue;
this.message = message;
this.format = format;
}
validate(name, value) {
if (value > this.maxValue) {
return wjcCore.format(this.message, {
0: name,
1: this._formatValue(this.maxValue)
});
}
return '';
}
}
export class MinNumberValidator extends MinValueValidator {
constructor(minValue, message = '{0} can\'t be less than {1}', format = 'n') {
super(minValue, message, format);
}
_formatValue(value) {
return wjcCore.Globalize.formatNumber(value, this.format);
}
}
export class MaxNumberValidator extends MaxValueValidator {
constructor(maxValue, message = '{0} can\'t be greater than {1}', format = 'n') {
super(maxValue, message, format);
}
_formatValue(value) {
return wjcCore.Globalize.formatNumber(value, this.format);
}
}
export class MinDateValidator extends MinValueValidator {
constructor(minValue, message = '{0} can\'t be less than {1}', format = 'MM/dd/yyyy') {
super(minValue, message, format);
}
_formatValue(value) {
return wjcCore.Globalize.formatDate(value, this.format);
}
}
export class MaxDateValidator extends MaxValueValidator {
constructor(maxValue, message = '{0} can\'t be greater than {1}', format = 'MM/dd/yyyy') {
super(maxValue, message, format);
}
_formatValue(value) {
return wjcCore.Globalize.formatDate(value, this.format);
}
}
<template>
<button class="btn btn-default btn-block" :disabled="preparing" @click="exportToExcel">
<span v-if="!exporting">Export To Excel</span>
<span v-else>Cancel ({{ percent(progress) }} done)</span>
</button>
</template>
<script setup>
import { ref } from "vue";
const props = defineProps({
exportService: Function,
getFlex: Function,
});
const preparing = ref(false);
const exporting = ref(false);
const progress = ref(0);
function exportToExcel() {
const resetState = () => {
preparing.value = false;
exporting.value = false;
progress.value = 0;
};
if (!preparing.value && !exporting.value) {
preparing.value = true;
props.exportService.startExcelExport(
props.getFlex(),
() => {
console.log("Export to Excel completed");
resetState();
},
(err) => {
console.error(`Export to Excel failed: ${err}`);
resetState();
},
(prg) => {
preparing.value = false;
exporting.value = true;
progress.value = prg;
},
);
console.log("Export to Excel started");
} else {
exportService.cancelExcelExportAsync(() => {
console.log("Export to Excel canceled");
resetState();
});
}
}
function percent(value) {
return `${Math.ceil(value)}%`;
}
</script>
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' },
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/latest/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.vue2.chart.analytics': 'cdn:@mescius/wijmo.vue2.chart.analytics/index.js',
'@mescius/wijmo.vue2.chart.animation': 'cdn:@mescius/wijmo.vue2.chart.animation/index.js',
'@mescius/wijmo.vue2.chart.annotation': 'cdn:@mescius/wijmo.vue2.chart.annotation/index.js',
'@mescius/wijmo.vue2.chart.finance.analytics': 'cdn:@mescius/wijmo.vue2.chart.finance.analytics/index.js',
'@mescius/wijmo.vue2.chart.finance': 'cdn:@mescius/wijmo.vue2.chart.finance/index.js',
'@mescius/wijmo.vue2.chart.hierarchical': 'cdn:@mescius/wijmo.vue2.chart.hierarchical/index.js',
'@mescius/wijmo.vue2.chart.interaction': 'cdn:@mescius/wijmo.vue2.chart.interaction/index.js',
'@mescius/wijmo.vue2.chart.radar': 'cdn:@mescius/wijmo.vue2.chart.radar/index.js',
'@mescius/wijmo.vue2.chart.map': 'cdn:@mescius/wijmo.vue2.chart.map/index.js',
'@mescius/wijmo.vue2.chart': 'cdn:@mescius/wijmo.vue2.chart/index.js',
'@mescius/wijmo.vue2.core': 'cdn:@mescius/wijmo.vue2.core/index.js',
'@mescius/wijmo.vue2.gauge': 'cdn:@mescius/wijmo.vue2.gauge/index.js',
'@mescius/wijmo.vue2.grid.detail': 'cdn:@mescius/wijmo.vue2.grid.detail/index.js',
'@mescius/wijmo.vue2.grid.filter': 'cdn:@mescius/wijmo.vue2.grid.filter/index.js',
'@mescius/wijmo.vue2.grid.grouppanel': 'cdn:@mescius/wijmo.vue2.grid.grouppanel/index.js',
'@mescius/wijmo.vue2.grid.search': 'cdn:@mescius/wijmo.vue2.grid.search/index.js',
'@mescius/wijmo.vue2.grid.multirow': 'cdn:@mescius/wijmo.vue2.grid.multirow/index.js',
'@mescius/wijmo.vue2.grid.sheet': 'cdn:@mescius/wijmo.vue2.grid.sheet/index.js',
'@mescius/wijmo.vue2.grid.transposed': 'cdn:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'cdn:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
'@mescius/wijmo.vue2.grid': 'cdn:@mescius/wijmo.vue2.grid/index.js',
'@mescius/wijmo.vue2.input': 'cdn:@mescius/wijmo.vue2.input/index.js',
'@mescius/wijmo.vue2.olap': 'cdn:@mescius/wijmo.vue2.olap/index.js',
'@mescius/wijmo.vue2.viewer': 'cdn:@mescius/wijmo.vue2.viewer/index.js',
'@mescius/wijmo.vue2.nav': 'cdn:@mescius/wijmo.vue2.nav/index.js',
'@mescius/wijmo.vue2.base': 'cdn:@mescius/wijmo.vue2.base/index.js',
'@mescius/wijmo.vue2.barcode.common': 'cdn:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'cdn:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'cdn:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
vue: 'pcdn:vue@3.4.21/dist/vue.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'vue-loader': 'pcdn:systemjs-vue-browser@1.0.11/index.js',
//'systemjs-plugin-vue': 'pcdn:systemjs-plugin-vue@1.2.0/index.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js',
},
rxjs: {
defaultExtension: 'js',
},
node_modules: {
defaultExtension: 'js',
},
wijmo: {
defaultExtension: 'js',
},
},
});
})(this);